      program ACWMsin2theta
c calculating sin^2 Theta using alphaQED package with hadronic contributions as tabled in hadr5n17.f
c using on-shell Mller scattering corrections for the SM boson contribution
c as calculated by A. Czarnecki and W. Marciano  Int.J.Mod.Phys. A15 (2000) 2365-2376  [hep-ph/0003049] 
c produces data for sin^2 Theta plot shown at the end of alphaQED17.pdf
      implicit none
      integer i,j,n,Nall,Nhigh,irange,nlow
      parameter(Nall=2187)
      real *8 X(Nall)
      INTEGER NA,NB
      PARAMETER(NA=979,NB=200)
      REAL ETX(NA),ESX(NB)
      double precision null,one,ha,two,four,sin2w,cos2w,alpfac,
     &     fivethird,mw2,mz2,mf,mf2,Q,Q2,q0,q1,x0,x1,xxx,dx,
     &     zf,z,rtf,rtb,logratf,lograt,sin2wofq,sin2wofqn,xxf,xxq,xxt,
     &     e,s,st2,der,errder,deg,errdeg,als,dahadr,dalept,daltop,mtop
      double precision kappa,kappasav,dkappaf,dkappab,alpi,ealpi,ql,t3l,
     &     dggvapx,degvapx,sin2w0,sin2wz,kappa0,kappamzrel,width,
     &     dkappab0,kappamzCM,kappamzFJ,sin2wzrel,sin2wzrelnew,big,
     &     kappah,kappal,sin2wofqh,sin2wofql,qx
      double precision xx(10),sl(10),sh(10)
      double precision mq(6),mp(6),qq(6),t3q(6)
      double precision dvpt1_new,dvpt1_hig,dvpt1_low,
     &     dvpt2_new,dvpt2_hig,dvpt2_low
      real*8 dglept,dghadr,dgetop,error,errorsta,errorsys,alp2
      real*8 Dalphaweak1MSb,Dalpha2weak1MSb,weaksav,weak2sav
      double precision dalhadc,dalhadh,dalhadl,deghadc,deghadh,deghadl
      double precision alphac,alphah,alphal,alpha2c,alpha2h,alpha2l
      double precision alphacW,alphahW,alphalW,
     &     alpha2cW,alpha2hW,alpha2lW,
     &     kappahW,kappalW,kappaW,sin2wofqnW,sin2wofqhW,sin2wofqlW
      double precision deltavertbox,cw2,mu2,sin2thetae,sin2thetaeW,
     &     sin2thetanumue,sin2relthetanumue
      double precision dvpt1_news,dvpt1_higs,dvpt1_lows,
     &     alphacs,alphahs,alphals
      double precision pi1,ALINP,ERRAL,EINP,MTOP1
      double precision sin2wofqT,sin2wofqnT,sin2wofqhT,sin2wofqlT
      external dggvapx,degvapx
********************* part to be included in main program **************
      include 'common.h'
      common/var1/pi1,ALINP,ERRAL,EINP,MTOP1
      common /parm/st2,als,mtop
      common /resu/dalept,dahadr,daltop,Dalphaweak1MSb
      common /resg/dglept,dghadr,dgetop,Dalpha2weak1MSb
c allowes to change W threshold default 2 M_W
      null=0.d0
      call constants()
      call constants_qcd()
c      sin2ell=0.23153 ! pm 0.00016 LEPEEWG Phys Rep 427 (2006) 257
      st2=0.23153d0   ! Reference value for weak mixing parameter
      als=ALINP       ! alpha strong
      mtop=MTOP1      ! top quark mass
c the parameter xMW [provided via common.h] allows to change W threshold default M_W, e.g. to xMW=2.d0*MW
c      xMW=null is set in constants ! default M_W
c      xMW=2.d0*MW
C LEPTONflag=all,had,lep,ele,muo,tau -> iLEP=-3,-2,-1,1,2,3
C Default:
C      LEPTONflag='all'
C      iLEP  = -3  ! for sum of leptons + quarks
C Decomment in main the following 2 lines for changing the default
c      LEPTONflag='all'   ! choose had,lep,top,ele,muo,tau
c      iLEP=LFLAG(LEPTONflag)
************************************************************************
c*********************     cut and move to main program    **************
c      include 'common.h'
c      common /parm/st2,als,mtop
c      common /resu/dalept,dahadr,daltop
c      common /resg/dglept,dghadr,dgetop,Dalpha2weak1MSb
cc      data pi /3.141592653589793d0/
      DATA alpi/137.035999084d0/
      DATA ealpi/000.000000051d0/
c      data ml /0.51099906d-3,105.658389d-3,1.7771d0/
c pQCD parameters
c quark masses MSbar mq, pole mp and thresholds th me errors dmp
      DATA MQ /0.005D0,0.009D0,0.190D0,1.286D0,4.164D0,163.4D0/
      DATA MP /0.005D0,0.009D0,0.190D0,1.666D0,4.800D0,171.3D0/
      include'xRdat-extended.f'
c      call constants()     ! QED constants, parameters
cC Decomment in main next 3 lines
c      st2=0.23d0          ! Reference value for weak mixing parameter
c      als=0.118d0         ! alpha strong
c      mtop=171.3d0        ! top quark mass
cC LEPTONflag=all,had,lep,ele,muo,tau -> iLEP=-3,-2,-1,1,2,3
cC Default:
cC      LEPTONflag='all'
cC      iLEP  = -3  ! for sum of leptons + quarks
cC Decomment in main the following 2 lines for changing the default
cc      LEPTONflag='all'   ! choose had,lep,top,ele,muo,tau
cc      iLEP=LFLAG(LEPTONflag)
c************************************************************************
      kappa0=0.96627387757987981d0
      sin2wz=0.23125d0
      sin2wz=0.23153d0  ! LEP 1 2006 update
      sin2w0=0.238375d0
      sin2wzrel=  0.231653d0/0.231799d0
c   91.187599    0.231530    0.000160    0.000160   sin2theteLEP
c   91.187600    0.231654    0.231355    0.231303    0.231406
c   91.187600    0.231654    0.231641    0.231638    0.231643
c      sin2wzrelnew=0.231530d0/0.232024d0/0.231355d0*0.231654d0
      sin2wzrelnew=sin2wz/0.231641
      sin2wzrelnew=sin2wz/ 0.231835d0
      sin2relthetanumue=0.231290d0/0.237684d0/sin2wzrel
      kappamzrel= 1.0004443374972163d0*0.96171003672576483d0
      kappamzrel= 1.0004443374972163d0*0.96213903265741285d0
      kappamzCM = 1.0004443374972163d0
      kappamzFJ = 0.96623659623152647d0
      mq(1)=0.1d0
      mq(2)=mq(1)
      mq(3)=mq(1)
      t3q(1)=1.d0/2.d0
      t3q(2)=-t3q(1)
      t3q(3)=t3q(2)
      t3q(4)=t3q(1)
      t3q(5)=t3q(2)
      t3q(6)=t3q(1)
      qq(1)=2.d0/3.d0
      qq(2)=-qq(1)/2.d0
      qq(3)=qq(2)
      qq(4)=qq(1)
      qq(5)=qq(2)
      qq(6)=qq(1)
      ql=-1.d0
      t3l=-1.d0/2.d0
      one=1.d0
      null=0.d0
      ha=0.5d0
      two=2.d0
      four=4.d0
      fivethird=5.d0/3.d0
      alp=one/alpi
      alp2=alp/st2
c      mw=80.399d0
c      mz=91.1876d0
      mw2=mw*mw
      mz2=mz*mz
      sin2w=0.23073d0  ! =/-0.00028  Czarnecki & Marciano sin2 theta_W(M_Z) MSbar
      sin2w=sin2wz
      st2=sin2w0
      cos2w=one-sin2w
      alpfac=alp*0.5d0/pi/sin2w
      n=500
      nhigh=n
      nlow=0
      q0=0.0020d0
c irange flag: 0=space-like, 1=time-like
      irange=1
c      irange=0
c      irange=-1
      if (irange.eq.1) then
c use resonance scan
         nlow=20
         n=nlow+Nall+Nhigh
      else if (irange.eq.-1) then
c standard however with time-like running couplings
         n=2000
         nhigh=n
      else if (irange.eq.0) then
c standard space-like channel
         n=2000
         nhigh=n
      endif
c precalculate kappa(M_Z)
c      q0=mz
c      qx=999.990d0
      q1=1400.00d0
      qx=q1
      x0=log10(q0)
      x1=log10(q1)
      dx=(x1-x0)/n
      xxx=x0
      write (1,*) '      2.0000'
      write (1,*) '      1.0000'
      write (1,*) '  ',float(n+1)
      write (3,*) '      2.0000'
      write (3,*) '      1.0000'
      write (3,*) '  ',float(n+1)
      write (7,*) '      2.0000'
      write (7,*) '      1.0000'
      write (7,*) '  ',float(n+1)
      write (8,*) '      2.0000'
      write (8,*) '      1.0000'
      write (8,*) '  ',float(n+1)
      write (9,*) '      2.0000'
      write (9,*) '      1.0000'
      write (9,*) '  ',float(n+1)
      big=1.d6
c resonance raster mode
      if (irange.eq.1) then
         x0=log10(q0)
         x1=log10(X(1))
         dx=(x1-x0)/nlow
         xxx=x0
         do j=1,nlow
            Q=10.d0**xxx
            Q2=Q*Q
            s=-Q2
            z=mw2/Q2
            if (z.gt.big) then
               dkappab=-alpfac*(-(42.d0*cos2w+one)/12.d0*log(cos2w)
     &              +one/18.d0+(6.d0*cos2w+7.d0)/18.d0)
     &              -(444.d0*cos2w+43.d0)/720.d0/z
     &              +(530.d0*cos2w+71.d0)/8400.d0/z/z
            else
               rtb=sqrt(one+four*z)
               lograt=log((rtb+one)/(rtb-one))
               dkappab=-alpfac*(-(42.d0*cos2w+one)/12.d0*log(cos2w)
     &              +one/18.d0
     &              -(ha*rtb*lograt-one)*((7.d0-four*z)*cos2w
     &              +one/6.d0*(one+four*z))
     &         -z*(0.75d0-z+(z-1.5d0)*rtb*lograt+z*(2.d0-z)*lograt**2))
            endif
            dkappab0=-alpfac*(-(42.d0*cos2w+one)/12.d0*log(cos2w)+
     &           one/18.d0+(6.d0*cos2w+7.d0)/18.d0)
            xxf=null
            xxq=null
            xxt=null
c leptons
            do i=1,3
               mf2=ml(i)**2
               zf=mf2/Q2
               if (zf.gt.big) then
                  xxf=xxf+(T3l*Ql-two*sin2w*Ql**2)*(log(mf2/mz2)
     &                 +1.d0/5.d0/zf-3.d0/140.d0/zf/zf)
               else
                  rtf=sqrt(one+four*zf)
                  logratf=log((rtf+one)/(rtf-one))
                  xxf=xxf+(T3l*Ql-two*sin2w*Ql**2)*(log(mf2/mz2)
     &                 -fivethird+four*zf+(one-two*zf)*rtf*logratf)
               endif
            enddo
c light quarks
            do i=1,5
               mf2=mq(i)**2
               zf=mf2/Q2
               if (zf.gt.big) then
                  xxq=xxq+3.d0*(T3q(i)*Qq(i)-two*sin2w*Qq(i)**2)*(
     &                 log(mf2/mz2)
     &                 +1.d0/5.d0/zf-3.d0/140.d0/zf/zf)
               else
                  rtf=sqrt(one+four*zf)
                  logratf=log((rtf+one)/(rtf-one))
                  xxq=xxq+3.d0*(T3q(i)*Qq(i)-two*sin2w*Qq(i)**2)*(
     &                 log(mf2/mz2)
     &                 -fivethird+four*zf+(one-two*zf)*rtf*logratf)
               endif
            enddo
            i=6
            mf2=mq(i)**2
            zf=mf2/Q2
            if (zf.gt.big) then
               xxt=3.d0*(T3q(i)*Qq(i)-two*sin2w*Qq(i)**2)*(
     &              log(mf2/mz2)
     &              +1.d0/5.d0/zf-3.d0/140.d0/zf/zf)
            else
               rtf=sqrt(one+four*zf)
               logratf=log((rtf+one)/(rtf-one))
               xxt=3.d0*(T3q(i)*Qq(i)-two*sin2w*Qq(i)**2)*(
     &              log(mf2/mz2)
     &              -fivethird+four*zf+(one-two*zf)*rtf*logratf)
            endif
            dkappaf=-alpfac*(xxf+xxq+xxt)/3.d0
            kappa=one+dkappaf
     &           +dkappab
            sin2wofq=sin2w*kappa
            kappasav=kappa
            e=-Q
C Attentione! dggvapx and degvapx return complete fermion contribution
            dvpt1_new= dggvapx(-s,error,errorsta,errorsys)
            dvpt1_news= dggvapx(s,error,errorsta,errorsys)
            dvpt2_new= degvapx(-s,error,errorsta,errorsys)
            dvpt1_hig= dvpt1_new+error
            dvpt1_low= dvpt1_new-error
            alphac =alp/(1.d0-dvpt1_new)
            alphah =alp/(1.d0-dvpt1_hig)
            alphal =alp/(1.d0-dvpt1_low)
            dvpt1_higs= dvpt1_new+error
            dvpt1_lows= dvpt1_new-error
            alphacs =alp/(1.d0-dvpt1_news)
            alphahs =alp/(1.d0-dvpt1_higs)
            alphals =alp/(1.d0-dvpt1_lows)
            dvpt2_hig= dvpt2_new+error
            dvpt2_low= dvpt2_new-error
            alpha2c =alp/(1.d0-dvpt2_new)
            alpha2h =alp/(1.d0-dvpt2_hig)
            alpha2l =alp/(1.d0-dvpt2_low)
            kappah=alphah/alpha2h
     &           +dkappab-dkappab0
            kappal=alphal/alpha2l
     &           +dkappab-dkappab0
            kappa=alphac/alpha2c
     &           +dkappab-dkappab0
            alphacW=alp/(1.d0-dvpt1_new-daltop-Dalphaweak1MSb)
            alphahW=alp/(1.d0-dvpt1_hig-daltop-Dalphaweak1MSb)
            alphalW=alp/(1.d0-dvpt1_low-daltop-Dalphaweak1MSb)
            alpha2cW=alp/(1.d0-dvpt2_new-dgetop-Dalpha2weak1MSb)
            alpha2hW=alp/(1.d0-dvpt2_hig-dgetop-Dalpha2weak1MSb)
            alpha2lW=alp/(1.d0-dvpt2_low-dgetop-Dalpha2weak1MSb)
            kappahW=alphahW/alpha2hW
            kappalW=alphalW/alpha2lW
            kappaW =alphacW/alpha2cW
c include neutrino charge radius
            mu2=ml(2)**2
            cw2=cos2w
            sin2thetanumue=st2
            deltavertbox=alp2/4.d0/pi*(2.d0/3.d0*(dlog(MW2/mu2+1.d0)
     &           +(24.d0*cw2**2-14.d0*cw2+9.d0)/4.d0*cw2))
            sin2thetae =(alphac/alpha2c+deltavertbox)*sin2thetanumue
            sin2thetaeW=(kappaW+deltavertbox)*sin2thetanumue
            weaksav=Dalphaweak1MSb
            weak2sav=Dalpha2weak1MSb
            sin2wofqn=st2*kappa*sin2wzrelnew
            sin2wofqh=st2*kappah*sin2wzrelnew
            sin2wofql=st2*kappal*sin2wzrelnew
            write (7,124) abs(Q),alphac,alphal,alphah,alphacs
            write (3,124) Q,kappasav,kappa,dkappab-dkappab0
c C & M effective pQCD, using hadr5n16.f central high low
            if (Q.lt.1000.d0) then
               sin2wofqT =sin2wofq 
               sin2wofqnT=sin2wofqn
               sin2wofqhT=sin2wofqh
               sin2wofqlT=sin2wofql
            endif
            if (Q.ge.1000.d0) then
               write (*,*) sin2wofqT,sin2wofqnT,sin2wofqhT,sin2wofqlT
c in the timelike region hadr5n data table ends at 1000. GeV
c match it to pQCD anaytic
               sin2wofqn =sin2wofqnT/sin2wofqT*sin2wofq 
               sin2wofqh =sin2wofqhT/sin2wofqT*sin2wofq 
               sin2wofql =sin2wofqlT/sin2wofqT*sin2wofq 
            endif
            write (1,124) Q,sin2wofq,sin2wofqn,sin2wofqh,sin2wofql
            sin2wofqnW=st2*kappaW *sin2wzrelnew
            sin2wofqhW=st2*kappahW*sin2wzrelnew
            sin2wofqlW=st2*kappalW*sin2wzrelnew
c VP effects only from hadr5n12.f central high low
            write (8,124) Q,sin2wofqnW,sin2wofqhW,sin2wofqlW
c including nu_mu-e scattering vertex + box: no W, with W, VP only no W, VP only with W
            write (9,124) Q,sin2thetae*sin2relthetanumue,
     &           sin2thetaeW*sin2relthetanumue,
     &           alphac/alpha2c*st2,kappaW*st2
            xxx=xxx+dx
         enddo
         do j=1,Nall
            e=x(j)
            Q=e
            s=e*e 
            Q2=Q*Q
            s=-Q2
            z=mw2/Q2
            if (z.gt.big) then
               dkappab=-alpfac*(-(42.d0*cos2w+one)/12.d0*log(cos2w)
     &              +one/18.d0+(6.d0*cos2w+7.d0)/18.d0)
     &              -(444.d0*cos2w+43.d0)/720.d0/z
     &              +(530.d0*cos2w+71.d0)/8400.d0/z/z
            else
               rtb=sqrt(one+four*z)
               lograt=log((rtb+one)/(rtb-one))
               dkappab=-alpfac*(-(42.d0*cos2w+one)/12.d0*log(cos2w)
     &              +one/18.d0
     &              -(ha*rtb*lograt-one)*((7.d0-four*z)*cos2w
     &              +one/6.d0*(one+four*z))
     &         -z*(0.75d0-z+(z-1.5d0)*rtb*lograt+z*(2.d0-z)*lograt**2))
            endif
            dkappab0=-alpfac*(-(42.d0*cos2w+one)/12.d0*log(cos2w)+
     &           one/18.d0+(6.d0*cos2w+7.d0)/18.d0)
            xxf=null
            xxq=null
            xxt=null
c leptons
            do i=1,3
               mf2=ml(i)**2
               zf=mf2/Q2
               if (zf.gt.big) then
                  xxf=xxf+(T3l*Ql-two*sin2w*Ql**2)*(log(mf2/mz2)
     &                 +1.d0/5.d0/zf-3.d0/140.d0/zf/zf)
               else
                  rtf=sqrt(one+four*zf)
                  logratf=log((rtf+one)/(rtf-one))
                  xxf=xxf+(T3l*Ql-two*sin2w*Ql**2)*(log(mf2/mz2)
     &                 -fivethird+four*zf+(one-two*zf)*rtf*logratf)
               endif
            enddo
c light quarks
            do i=1,5
               mf2=mq(i)**2
               zf=mf2/Q2
               if (zf.gt.big) then
                  xxq=xxq+3.d0*(T3q(i)*Qq(i)-two*sin2w*Qq(i)**2)*(
     &                 log(mf2/mz2)
     &                 +1.d0/5.d0/zf-3.d0/140.d0/zf/zf)
               else
                  rtf=sqrt(one+four*zf)
                  logratf=log((rtf+one)/(rtf-one))
                  xxq=xxq+3.d0*(T3q(i)*Qq(i)-two*sin2w*Qq(i)**2)*(
     &                 log(mf2/mz2)
     &                 -fivethird+four*zf+(one-two*zf)*rtf*logratf)
               endif
            enddo
            i=6
            mf2=mq(i)**2
            zf=mf2/Q2
            if (zf.gt.big) then
               xxt=3.d0*(T3q(i)*Qq(i)-two*sin2w*Qq(i)**2)*(
     &              log(mf2/mz2)
     &              +1.d0/5.d0/zf-3.d0/140.d0/zf/zf)
            else
               rtf=sqrt(one+four*zf)
               logratf=log((rtf+one)/(rtf-one))
               xxt=3.d0*(T3q(i)*Qq(i)-two*sin2w*Qq(i)**2)*(
     &              log(mf2/mz2)
     &              -fivethird+four*zf+(one-two*zf)*rtf*logratf)
            endif
            dkappaf=-alpfac*(xxf+xxq+xxt)/3.d0
            kappa=one+dkappaf
     &           +dkappab
            sin2wofq=sin2w*kappa
            kappasav=kappa
            e=-Q
C Attentione! dggvapx and degvapx return complete fermion contribution
            dvpt1_new= dggvapx(-s,error,errorsta,errorsys)
            dvpt1_news= dggvapx(s,error,errorsta,errorsys)
            dvpt2_new= degvapx(-s,error,errorsta,errorsys)
            dvpt1_hig= dvpt1_new+error
            dvpt1_low= dvpt1_new-error
            alphac =alp/(1.d0-dvpt1_new)
            alphah =alp/(1.d0-dvpt1_hig)
            alphal =alp/(1.d0-dvpt1_low)
            dvpt1_higs= dvpt1_new+error
            dvpt1_lows= dvpt1_new-error
            alphacs =alp/(1.d0-dvpt1_news)
            alphahs =alp/(1.d0-dvpt1_higs)
            alphals =alp/(1.d0-dvpt1_lows)
            dvpt2_hig= dvpt2_new+error
            dvpt2_low= dvpt2_new-error
            alpha2c =alp/(1.d0-dvpt2_new)
            alpha2h =alp/(1.d0-dvpt2_hig)
            alpha2l =alp/(1.d0-dvpt2_low)
            kappah=alphah/alpha2h
     &           +dkappab-dkappab0
            kappal=alphal/alpha2l
     &           +dkappab-dkappab0
            kappa=alphac/alpha2c
     &           +dkappab-dkappab0
            alphacW=alp/(1.d0-dvpt1_new-daltop-Dalphaweak1MSb)
            alphahW=alp/(1.d0-dvpt1_hig-daltop-Dalphaweak1MSb)
            alphalW=alp/(1.d0-dvpt1_low-daltop-Dalphaweak1MSb)
            alpha2cW=alp/(1.d0-dvpt2_new-dgetop-Dalpha2weak1MSb)
            alpha2hW=alp/(1.d0-dvpt2_hig-dgetop-Dalpha2weak1MSb)
            alpha2lW=alp/(1.d0-dvpt2_low-dgetop-Dalpha2weak1MSb)
            kappahW=alphahW/alpha2hW
            kappalW=alphalW/alpha2lW
            kappaW =alphacW/alpha2cW
c include neutrino charge radius
            mu2=ml(2)**2
            cw2=cos2w
            sin2thetanumue=st2
            deltavertbox=alp2/4.d0/pi*(2.d0/3.d0*(dlog(MW2/mu2+1.d0)
     &           +(24.d0*cw2**2-14.d0*cw2+9.d0)/4.d0*cw2))
            sin2thetae =(alphac/alpha2c+deltavertbox)*sin2thetanumue
            sin2thetaeW=(kappaW+deltavertbox)*sin2thetanumue
            weaksav=Dalphaweak1MSb
            weak2sav=Dalpha2weak1MSb
            sin2wofqn=st2*kappa*sin2wzrelnew
            sin2wofqh=st2*kappah*sin2wzrelnew
            sin2wofql=st2*kappal*sin2wzrelnew
            write (7,124) abs(Q),alphac,alphal,alphah,alphacs
            write (3,124) Q,kappasav,kappa,dkappab-dkappab0
c C & M effective pQCD, using hadr5n12.f central high low
            if (Q.lt.1000.d0) then
               sin2wofqT =sin2wofq 
               sin2wofqnT=sin2wofqn
               sin2wofqhT=sin2wofqh
               sin2wofqlT=sin2wofql
            endif
            if (Q.ge.1000.d0) then
               write (*,*) sin2wofqT,sin2wofqnT,sin2wofqhT,sin2wofqlT
c in the timelike region hadr5n data table ends at 1000. GeV
c match it to pQCD anaytic
               sin2wofqn =sin2wofqnT/sin2wofqT*sin2wofq 
               sin2wofqh =sin2wofqhT/sin2wofqT*sin2wofq 
               sin2wofql =sin2wofqlT/sin2wofqT*sin2wofq 
            endif
            write (1,124) Q,sin2wofq,sin2wofqn,sin2wofqh,sin2wofql
            sin2wofqnW=st2*kappaW *sin2wzrelnew
            sin2wofqhW=st2*kappahW*sin2wzrelnew
            sin2wofqlW=st2*kappalW*sin2wzrelnew
c VP effects only from hadr5n12.f central high low
            write (8,124) Q,sin2wofqnW,sin2wofqhW,sin2wofqlW
c including nu_mu-e scattering vertex + box: no W, with W, VP only no W, VP only with W
            write (9,124) Q,sin2thetae*sin2relthetanumue,
     &           sin2thetaeW*sin2relthetanumue,
     &           alphac/alpha2c*st2,kappaW*st2
         enddo
      endif
      if (irange.eq.1) q0=x(Nall)
      x0=log10(q0)
      x1=log10(q1)
      dx=(x1-x0)/nhigh
      xxx=x0
      if (irange.eq.1) xxx=xxx+dx
      do j=1,nhigh+2
         Q=10.d0**xxx
c         write (*,*) ' q=',q
         if (j.eq.nhigh+2) Q=mz
         Q2=Q*Q
         s=-Q2
         z=mw2/Q2
c         z=mz2/Q2
         if (z.gt.big) then
            dkappab=-alpfac*(-(42.d0*cos2w+one)/12.d0*log(cos2w)
     &           +one/18.d0+(6.d0*cos2w+7.d0)/18.d0)
     &           -(444.d0*cos2w+43.d0)/720.d0/z
     &           +(530.d0*cos2w+71.d0)/8400.d0/z/z
         else
            rtb=sqrt(one+four*z)
            lograt=log((rtb+one)/(rtb-one))
            dkappab=-alpfac*(-(42.d0*cos2w+one)/12.d0*log(cos2w)
     &           +one/18.d0
     &           -(ha*rtb*lograt-one)*((7.d0-four*z)*cos2w
     &           +one/6.d0*(one+four*z))
     &        -z*(0.75d0-z+(z-1.5d0)*rtb*lograt+z*(2.d0-z)*lograt**2))
         endif
         dkappab0=-alpfac*(-(42.d0*cos2w+one)/12.d0*log(cos2w)+one/18.d0
     &        +(6.d0*cos2w+7.d0)/18.d0)
         xxf=null
         xxq=null
         xxt=null
c leptons
         do i=1,3
            mf2=ml(i)**2
            zf=mf2/Q2
            if (zf.gt.big) then
               xxf=xxf+(T3l*Ql-two*sin2w*Ql**2)*(log(mf2/mz2)
     &              +1.d0/5.d0/zf-3.d0/140.d0/zf/zf)
            else
               rtf=sqrt(one+four*zf)
               logratf=log((rtf+one)/(rtf-one))
               xxf=xxf+(T3l*Ql-two*sin2w*Ql**2)*(log(mf2/mz2)
     &              -fivethird+four*zf+(one-two*zf)*rtf*logratf)
            endif
         enddo
c light quarks
         do i=1,5
            mf2=mq(i)**2
            zf=mf2/Q2
            if (zf.gt.big) then
               xxq=xxq+3.d0*(T3q(i)*Qq(i)-two*sin2w*Qq(i)**2)*(
     &              log(mf2/mz2)
     &              +1.d0/5.d0/zf-3.d0/140.d0/zf/zf)
            else
               rtf=sqrt(one+four*zf)
               logratf=log((rtf+one)/(rtf-one))
               xxq=xxq+3.d0*(T3q(i)*Qq(i)-two*sin2w*Qq(i)**2)*(
     &              log(mf2/mz2)
     &              -fivethird+four*zf+(one-two*zf)*rtf*logratf)
            endif
         enddo
         i=6
            mf2=mq(i)**2
            zf=mf2/Q2
            if (zf.gt.big) then
               xxt=3.d0*(T3q(i)*Qq(i)-two*sin2w*Qq(i)**2)*(
     &              log(mf2/mz2)
     &              +1.d0/5.d0/zf-3.d0/140.d0/zf/zf)
            else
               rtf=sqrt(one+four*zf)
               logratf=log((rtf+one)/(rtf-one))
               xxt=3.d0*(T3q(i)*Qq(i)-two*sin2w*Qq(i)**2)*(
     &              log(mf2/mz2)
     &              -fivethird+four*zf+(one-two*zf)*rtf*logratf)
            endif
         dkappaf=-alpfac*(xxf+xxq+xxt)/3.d0
         kappa=one+dkappaf
     &        +dkappab
         sin2wofq=sin2w*kappa
c     &        *kappamzCM
         kappasav=kappa
         e=-Q
C Attentione! dggvapx and degvapx return complete fermion contribution
         if (Q.le.qx) then
            if (irange.eq.0) then
               dvpt1_new= dggvapx(s,error,errorsta,errorsys)
               dvpt1_news= dggvapx(s,error,errorsta,errorsys)
               dvpt2_new= degvapx(s,error,errorsta,errorsys)
            else 
               dvpt1_new= dggvapx(-s,error,errorsta,errorsys)
               dvpt1_news= dggvapx(s,error,errorsta,errorsys)
               dvpt2_new= degvapx(-s,error,errorsta,errorsys)
            endif
            dvpt1_hig= dvpt1_new+error
            dvpt1_low= dvpt1_new-error
            alphac =alp/(1.d0-dvpt1_new)
            alphah =alp/(1.d0-dvpt1_hig)
            alphal =alp/(1.d0-dvpt1_low)
            dvpt1_higs= dvpt1_new+error
            dvpt1_lows= dvpt1_new-error
            alphacs =alp/(1.d0-dvpt1_news)
            alphahs =alp/(1.d0-dvpt1_higs)
            alphals =alp/(1.d0-dvpt1_lows)
            dvpt2_hig= dvpt2_new+error
            dvpt2_low= dvpt2_new-error
            alpha2c =alp/(1.d0-dvpt2_new)
            alpha2h =alp/(1.d0-dvpt2_hig)
            alpha2l =alp/(1.d0-dvpt2_low)
            kappah=alphah/alpha2h
     &           +dkappab-dkappab0
            kappal=alphal/alpha2l
     &           +dkappab-dkappab0
            kappa=alphac/alpha2c
     &           +dkappab-dkappab0
            alphacW=alp/(1.d0-dvpt1_new-daltop-Dalphaweak1MSb)
            alphahW=alp/(1.d0-dvpt1_hig-daltop-Dalphaweak1MSb)
            alphalW=alp/(1.d0-dvpt1_low-daltop-Dalphaweak1MSb)
            alpha2cW=alp/(1.d0-dvpt2_new-dgetop-Dalpha2weak1MSb)
            alpha2hW=alp/(1.d0-dvpt2_hig-dgetop-Dalpha2weak1MSb)
            alpha2lW=alp/(1.d0-dvpt2_low-dgetop-Dalpha2weak1MSb)
            kappahW=alphahW/alpha2hW
            kappalW=alphalW/alpha2lW
            kappaW =alphacW/alpha2cW
c include neutrino charge radius
            mu2=ml(2)**2
            cw2=cos2w
            sin2thetanumue=st2
            deltavertbox=alp2/4.d0/pi*(2.d0/3.d0*(dlog(MW2/mu2+1.d0)
     &           +(24.d0*cw2**2-14.d0*cw2+9.d0)/4.d0*cw2))
            sin2thetae =(alphac/alpha2c+deltavertbox)*sin2thetanumue
            sin2thetaeW=(kappaW+deltavertbox)*sin2thetanumue
c
c         dalhadh= dggvapx(s, 1.d0)
c         deghadh= degvapx(s, 1.d0)
c         kappah=(one-dglept-dghadr-dgetop)/(one-dalept-dahadr-daltop)
c     &        +dkappab-dkappab0
c         kappah=(one-deghadh)/(one-dalhadh)
c     &        +dkappab-dkappab0
c         dalhadl= dggvapx(s,-1.d0)
c         deghadl= degvapx(s,-1.d0)
c         kappal=(one-dglept-dghadr-dgetop)/(one-dalept-dahadr-daltop)
c     &        +dkappab-dkappab0
c         kappal=(one-deghadl)/(one-dalhadl)
c     &        +dkappab-dkappab0
c         dalhadc= dggvapx(s, 0.d0)
            weaksav=Dalphaweak1MSb
c         deghadc= degvapx(s, 0.d0)
            weak2sav=Dalpha2weak1MSb
c         kappa=(one-dglept-dghadr-dgetop)/(one-dalept-dahadr-daltop)
c     &        +dkappab-dkappab0
c         kappa=(one-deghadc)/(one-dalhadc)
c     &        +dkappab-dkappab0
c         kappa=(one-dglept-dghadr-dgetop+dalept+dahadr+daltop)
c     &        +dkappab
c         kappa=(one-dghadr-dgetop+dahadr+dkappaf)
c     &        +dkappab
c         kappa=(one-deghadc)/(one-dalhadc)+dkappab+dkappaf
c         sin2wofqn=sin2w*kappa/kappamzrel
c         sin2wofqn=sin2w*kappa/kappamzFJ
            sin2wofqn=st2*kappa*sin2wzrelnew
            sin2wofqh=st2*kappah*sin2wzrelnew
            sin2wofql=st2*kappal*sin2wzrelnew
         else
            sin2wofqn=sin2wofq
            sin2wofqh=sin2wofq
            sin2wofql=sin2wofq
         endif
c         del=(sin2wofqh-sin2wql)/2.d0
         write (7,124) abs(Q),alphac,alphal,alphah,alphacs
         write (3,124) Q,kappasav,kappa,dkappab-dkappab0
c C & M effective pQCD, using hadr5n12.f central high low
            if (Q.lt.1000.d0) then
               sin2wofqT =sin2wofq 
               sin2wofqnT=sin2wofqn
               sin2wofqhT=sin2wofqh
               sin2wofqlT=sin2wofql
            endif
            if (Q.ge.1000.d0) then
               write (*,*) sin2wofqT,sin2wofqnT,sin2wofqhT,sin2wofqlT
c in the timelike region hadr5n data table ends at 1000. GeV
c match it to pQCD anaytic
               sin2wofqn =sin2wofqnT/sin2wofqT*sin2wofq 
               sin2wofqh =sin2wofqhT/sin2wofqT*sin2wofq 
               sin2wofql =sin2wofqlT/sin2wofqT*sin2wofq 
            endif
         write (1,124) Q,sin2wofq,sin2wofqn,sin2wofqh,sin2wofql
         sin2wofqnW=st2*kappaW *sin2wzrelnew
         sin2wofqhW=st2*kappahW*sin2wzrelnew
         sin2wofqlW=st2*kappalW*sin2wzrelnew
c VP effects only from hadr5n12.f central high low
         write (8,124) Q,sin2wofqnW,sin2wofqhW,sin2wofqlW
c including nu_mu-e scattering vertex + box: no W, with W, VP only no W, VP only with W
         write (9,124) Q,sin2thetae*sin2relthetanumue,
     &        sin2thetaeW*sin2relthetanumue,
     &        alphac/alpha2c*st2,kappaW*st2
         xxx=xxx+dx
      enddo
c for plotting purpose: header for graphx ploting program
c data to compare with 6 true experimental points 4 future expectations
c    ! Cs APV
c    ! Moller SLAC E 158
c    ! nu-DIS NuTeV
c    ! LEP 1
c    ! SLD A_LR
c    ! Tevatron
c    ! project Moller Jlab
c    ! project Qweak Jlab
c    ! project PV-DIS Jlab
c    ! project ILC
c energies in GeV
      xx(1) =    0.002400
      xx(2) =    0.161245
      xx(3) =   20.000000
      xx(4) =   91.187600
      xx(5) =   91.187600
      xx(6) =  105.187600
      xx(7) =    0.089314
      xx(8) =    0.161655
      xx(9) =    1.888311
      xx(10)= 1000.000000
c sin^2 Theta central values
      sl(1) = 0.238100
      sl(2) = 0.239700
      sl(3) = 0.236000
      sl(4) = 0.231530
      sl(5) = 0.230980
      sl(6) = 0.231600
      sl(7) = 0.237950
      sl(8) = 0.237850
      sl(9) = 0.236200
      sl(10)= 0.238000
c errors
      sh(1) = 0.002000
      sh(2) = 0.001300
      sh(3) = 0.001600
      sh(4) = 0.000160
      sh(5) = 0.000260
      sh(6) = 0.001800
      sh(7) = 0.000250
      sh(8) = 0.000750
      sh(9) = 0.000600
      sh(10)= 0.000250
      write (2,*) '      2.0000'
      write (2,*) '     10.0000'
      write (2,*) '      1.0000'
      write (4,*) '      2.0000'
      write (4,*) '      1.0000'
      write (4,*) '      1.0000'
      do i=1,10
         write (2,124) xx(i),sl(i),sh(i),sh(i)
      enddo
      i=4  ! LEP 1 renormalization reference point
      write (4,124) xx(i),sl(i),sh(i),sh(i)
124   format(1x,f11.6,4(1x,f11.6))
      stop
      end
