#!/bin/csh -fx
if ("$1" == "") goto usage

  set DAT_FILES=( intRdatx_gg_check.dap \
		intRdatx.tab dalhads.dat flavors.dat intRdatx.dap intRdatx_gg.dap intRdatx_3g.dap intRdatx_33.dap intRdatx_n2.dap)

echo $DAT_FILES

  foreach i ($DAT_FILES)
    if ( -r $i ) then
      rm -f $i
      continue
    endif
  end

  set KIL_FILES=( EClabel \
		intRdatx.dat intRdatx_gg.dat intRdatx_3g.dat intRdatx_33.dat)

  foreach i ($KIL_FILES)
    if ( -r $i ) then
      rm -f $i 
      continue
    endif
  end

make -f Makefile_iRdx

if ("$1" == "0") then 
echo ' running  intRdatx < ECintR.inp'
time ./intRdatx < ECintR.inp
exit
endif
if ("$1" == "gg2lin") then 
cat ECintR.inp0 > ECintR.inp$1
cat >> ECintR.inp$1 <<_EOF_
8,0,2,'LIN'
# gg2lin = EC t^3*G_2(t), <gg>, NFL=2, 'LIN'
_EOF_
set name = $1
endif
if ("$1" == "gg3lin") then 
cat ECintR.inp0 > ECintR.inp$1
cat >> ECintR.inp$1 <<_EOF_
8,0,3,'LIN'
# gg3lin = EC t^3*G_2(t), <gg>, NFL=3, 'LIN'
_EOF_
set name = $1
endif
if ("$1" == "gg4lin") then 
cat ECintR.inp0 > ECintR.inp$1
cat >> ECintR.inp$1 <<_EOF_
8,0,4,'LIN'
# gg4lin = EC t^3*G_2(t), <gg>, NFL=4, 'LIN'
_EOF_
set name = $1
endif
if ("$1" == "gg5lin") then 
cat ECintR.inp0 > ECintR.inp$1
cat >> ECintR.inp$1 <<_EOF_
8,0,5,'LIN'
# gg5lin = EC t^3*G_2(t), <gg>, NFL=5, 'LIN'
_EOF_
set name = $1
endif
if ("$1" == "gg2log") then 
cat ECintR.inp0 > ECintR.inp$1
cat >> ECintR.inp$1 <<_EOF_
8,0,2,'LOG'
# gg2log = EC t^3*G_2(t), <gg>, NFL=2, 'LOG'
_EOF_
set name = $1
endif
if ("$1" == "gg3log") then 
cat ECintR.inp0 > ECintR.inp$1
cat >> ECintR.inp$1 <<_EOF_
8,0,3,'LOG'
# gg3log = EC t^3*G_2(t), <gg>, NFL=3, 'LOG'
_EOF_
set name = $1
endif
if ("$1" == "gg4log") then 
cat ECintR.inp0 > ECintR.inp$1
cat >> ECintR.inp$1 <<_EOF_
8,0,4,'LOG'
# gg4log = EC t^3*G_2(t), <gg>, NFL=4, 'LOG'
_EOF_
set name = $1
endif
if ("$1" == "gg5log") then 
cat ECintR.inp0 > ECintR.inp$1
cat >> ECintR.inp$1 <<_EOF_
8,0,5,'LOG'
# gg5log = EC t^3*G_2(t), <gg>, NFL=5, 'LOG'
_EOF_
set name = $1
endif
if ("$1" == "3g2lin") then 
cat ECintR.inp0 > ECintR.inp$1
cat >> ECintR.inp$1 <<_EOF_
8,2,2,'LIN'
# 3g2lin = EC t^3*G_2(t), <3g>, NFL=2, 'LIN'
_EOF_
set name = $1
endif
if ("$1" == "3g3lin") then 
cat ECintR.inp0 > ECintR.inp$1
cat >> ECintR.inp$1 <<_EOF_
8,2,3,'LIN'
# 3g3lin = EC t^3*G_2(t), <3g>, NFL=3, 'LIN'
_EOF_
set name = $1
endif
if ("$1" == "3g4lin") then 
cat ECintR.inp0 > ECintR.inp$1
cat >> ECintR.inp$1 <<_EOF_
8,2,4,'LIN'
# 3g4lin = EC t^3*G_2(t), <3g>, NFL=4, 'LIN'
_EOF_
set name = $1
endif
if ("$1" == "3g5lin") then 
cat ECintR.inp0 > ECintR.inp$1
cat >> ECintR.inp$1 <<_EOF_
8,2,5,'LIN'
# 3g5lin = EC t^3*G_2(t), <3g>, NFL=5, 'LIN'
_EOF_
set name = $1
endif
if ("$1" == "3g2log") then 
cat ECintR.inp0 > ECintR.inp$1
cat >> ECintR.inp$1 <<_EOF_
8,2,2,'LOG'
# 3g2log = EC t^3*G_2(t), <3g>, NFL=2, 'LOG'
_EOF_
set name = $1
endif
if ("$1" == "3g3log") then 
cat ECintR.inp0 > ECintR.inp$1
cat >> ECintR.inp$1 <<_EOF_
8,2,3,'LOG'
# 3g3log = EC t^3*G_2(t), <3g>, NFL=3, 'LOG'
_EOF_
set name = $1
endif
if ("$1" == "3g4log") then 
cat ECintR.inp0 > ECintR.inp$1
cat >> ECintR.inp$1 <<_EOF_
8,2,4,'LOG'
# 3g4log = EC t^3*G_2(t), <3g>, NFL=4, 'LOG'
_EOF_
set name = $1
endif
if ("$1" == "3g5log") then 
cat ECintR.inp0 > ECintR.inp$1
cat >> ECintR.inp$1 <<_EOF_
8,2,5,'LOG'
# 3g5log = EC t^3*G_2(t), <3g>, NFL=5, 'LOG'
_EOF_
set name = $1
endif

echo ' run intRdatx'
time ./intRdatx < ECintR.inp$1

if ("$?" == "0") then
	
if ("$name" == "gg5lin") then
cp intRdatx_gg.dap  ./dat/EC$name.dap
else if ("$name" == "gg5log") then
cp intRdatx_gg.dap  ./dat/EC$name.dap
else if ("$name" == "gg2lin") then
cp intRdatx_n2.dap  ./dat/EC$name.dap
else if ("$name" == "gg2log") then
cp intRdatx_n2.dap  ./dat/EC$name.dap
else
cp intRdatx_3g.dap  ./dat/EC$name.dap
endif

endif

echo ' For different range adapt ECintR.inp0 '

exit

exit 0
usage:
echo "Usage intRdatx option EC channel=0 <gg>"
echo " 0 input set from ECintR.inp"
echo " gg2lin = EC t^3*G_2(t), <gg>, NFL=2, 'LIN' "
echo " gg3lin = EC t^3*G_2(t), <gg>, NFL=3, 'LIN' "
echo " gg4lin = EC t^3*G_2(t), <gg>, NFL=4, 'LIN' "
echo " gg5lin = EC t^3*G_2(t), <gg>, NFL=5, 'LIN' "
echo " gg2log = EC t^3*G_2(t), <gg>, NFL=2, 'LOG' "
echo " gg3log = EC t^3*G_2(t), <gg>, NFL=3, 'LOG' "
echo " gg4log = EC t^3*G_2(t), <gg>, NFL=4, 'LOG' "
echo " gg5log = EC t^3*G_2(t), <gg>, NFL=5, 'LOG' "
exit 2
