c;;;;;;;;;;;;;;;;;;;;;;;;;;;; -*- Mode: Fortran -*- ;;;;;;;;;;;;;;;;;;;;;;;;;;;
c;; FSRfun.f --- 
c;; Author          : Fred Jegerlehner
c;; Created On      : Thu Mar 28 03:03:06 2002
c;; Last Modified By: Friedrich Jegerlehner
c;; Last Modified On: Fri Feb 26 17:58:30 2010
c;; RCS: $Id$
c;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
c;; Copyright (c) 2002 Fred Jegerlehner
c;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
c;; 
      subroutine FSRfun(s,mpi2,epeta)
c FSR for pi+pi- in sQED: epeta(1)=1+eta(s); epeta(2) same with coulomb exponentiated
c Linkfiles: ddilog
      implicit none
      real *8 bpi,mpi2,s,bpi2,xi,xii,logxii,padb,eta,ddilog,epeta(2),
     &     pi,alp
      common /FSRpar/pi,alp/teta/eta
      bpi=sqrt(1.d0-4.d0*mpi2/s)
      bpi2=bpi*bpi
      xi =(1.d0-bpi)/(1.d0+bpi)
      xii=1.d0/xi
      logxii=log(xii)
      padb=pi*alp/bpi
      eta=(1.d0+bpi2)/bpi
     &   *(4.d0*ddilog(xi)+2.d0*ddilog(-xi)
     &   -(3.d0*log(2.d0/(1.d0+bpi))+2.d0*log(bpi))*logxii)
     &    -3.d0*log(4.d0/(1.d0-bpi2))-4.d0*log(bpi)
     &    +1.d0/bpi**3*(5.d0/4.d0*(1.d0+bpi2)**2-2.d0)*logxii
     &    +3.d0/2.d0*(1.d0+bpi2)/(bpi2)
      epeta(1)=1.d0+alp/pi*eta
      epeta(2)=(epeta(1)-0.5d0*padb)
     &         *padb/(1.d0-exp(-padb))
      return
      end
