*;;;;;;;;;;;;;;;;;;;;;;;;;;;;; -*- Mode: Fortran -*- ;;;;;;;;;;;;;;;;;;;;;;;;;;;
*;; alphaQEDr_sub.f ---
*;; Author          : Fred Jegerlehner
*;; Created On      : Wed Jan 11 03:26:27 2006
*;; Last Modified By: Friedrich Jegerlehner
*;; Last Modified On: Tue Jul 18 02:40:18 2017
*;; RCS: $Id$
*;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
*;; Copyright (c) 2010 Fred Jegerlehner
*;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
*;;
      SUBROUTINE alphaQEDrx(s,dvpt_new,dvpt_hig,dvpt_low,alphac,alphah
     &     ,alphal,alphact,alphaht,alphalt,dalept1,dahadr1,daltop1)
C Link files dggvap14,dhadr5n14,
C Calculating the running QED coupling alpha(E)
C Leptons: 1--loop, 2--loop exact, 3--loop in high energy approximation
C Quarks form routine dhadr5n including effective s--channel shifts in low energy range
C r1....,r2....,r3.... : one-loop, two-loop, three-loop result
C  ..real: real part, ..imag: imaginary part;
C ......l: light fermions only (high energy approximation for 3--loops)
C dallepQED1n=r1real,dallepQED2n=r2real,dallepQED3l=r3reall
C dallepQED3l also returns one-loop and two-loop high energy (light fermion) approximations
      implicit none
      double precision dggvapx,error,errorsta,errorsys,
     &     dalept,dahadr,daltop,Dalphaweak1MSb
      double precision s,dvpt_new,dvpt_hig,dvpt_low,alphac,alphah
     &     ,alphal,alphact,alphaht,alphalt,dalept1,dahadr1,daltop1
      external dggvapx
********************* part to be included and edited in main program **************
c decommment next line in main
c      double precision pi1,ALINP,ERRAL,EINP,MTOP1 ! get QCD parameters as set in constants_qcd
c some QCD parameters required to calculare top contribution 
      include 'common.h'      
c decommment next 2 lines in main
c      common/var1/pi1,ALINP,ERRAL,EINP,MTOP1
c      common /parm/st2,als,mtop
      common /resu/dalept,dahadr,daltop,Dalphaweak1MSb
c decommment next 2 lines in main
c      call constants()
c      call constants_qcd()
c      sin2ell=0.23153 ! pm 0.00016 LEPEEWG Phys Rep 427 (2006) 257
c decommment next line and change default as appropriate in main      
c      st2=0.23153d0   ! Reference value for weak mixing parameter
c decommment next 2 lines in main
c      als=ALINP       ! alpha strong
c      mtop=MTOP1      ! top quark mass
C LEPTONflag=all,had,lep,ele,muo,tau -> iLEP=-3,-2,-1,1,2,3
C Default: 
C      LEPTONflag='all'
C      iLEP  = -3  ! for sum of leptons + quarks              
C decomment in main the following 2 lines for changing the default
c      LEPTONflag='all'   ! choose had,lep,top,ele,muo,tau
c      iLEP=LFLAG(LEPTONflag)
************************************************************************
c     vacuum polarization
c
c      ' e,dalpha,dalpha_low,dalpha_hig (no top)'
c      ' e,alpha ,alphal ,alphah (no top)    '
c      ' e,alphat,alphalt,alphaht (with top and W)   '
c      ' e,dalept,dahadr,daltop' (individual)
c
      dvpt_new= dggvapx(s,error,errorsta,errorsys)    ! central value
      dvpt_hig= dvpt_new+error              !    ...        + total error
      dvpt_low= dvpt_new-error              !    ...        - total error
      alphac  =alp/(1.d0-dvpt_new)          ! alpha no top
      alphah  =alp/(1.d0-dvpt_hig)
      alphal  =alp/(1.d0-dvpt_low)
      alphact =alp/(1.d0-dvpt_new-daltop-Dalphaweak1MSb)   ! alpha incl top and W
      alphaht =alp/(1.d0-dvpt_hig-daltop-Dalphaweak1MSb)
      alphalt =alp/(1.d0-dvpt_low-daltop-Dalphaweak1MSb)
      dalept1 =dalept                       ! lepton VP
      dahadr1 =dahadr                       ! hadronic VP 5 flavors
      daltop1 =daltop                       ! top contribution
c
c     delta alpha: leptons + 5 quarks no top
c
c     e,dvpt_new,dvpt_low,dvpt_hig
c
c     alpha: leptons + 5 quarks no top
c
c     e,alphac ,alphal ,alphah
c
c     alpha: leptons + 5 quarks + top + W (1-loop MSbar) [above 2 M_W threshold]
c
c     e,alphact,alphalt,alphaht
c
c     delta alpha: leptons, 5 quarks, top
c
c     e,dalept,dahadr,daltop
c
      return
      END
c
