      PROGRAM amuviaEC
*     D01AMF Example Program Text
*     Mark 14 Revised. NAG Copyright 1989.
*     .. Parameters ..
      INTEGER          LW, LIW
      PARAMETER        (LW=8000,LIW=LW/4)
      INTEGER          NOUT
      PARAMETER        (NOUT=6)
*     .. Scalars in Common ..
      INTEGER          KOUNT
*     .. Local Scalars ..
      DOUBLE PRECISION A, ABSERR, B, EPSABS, EPSREL, RESULT
      INTEGER          IFAIL
*     .. Local Arrays ..
      DOUBLE PRECISION W(LW)
      INTEGER          IW(LIW)
*     .. External Functions ..
      DOUBLE PRECISION FST
      EXTERNAL         FST
*     .. External Subroutines ..
      EXTERNAL         D01AJF
*     .. Common blocks ..
      COMMON           /TELNUM/KOUNT
      integer I,IER,nf
      real rt,rECgg,errstaECgg,errsysECgg
      DOUBLE PRECISION fm,alp,mu2,t,alpi,gmu,ealpi,ergmu,fac
      DOUBLE PRECISION RES(3),ml(3),erml(3)
      double precision dt,dECgg,derrstaECgg,derrsysECgg,ECLQCDKERN
      EXTERNAL ECLQCDKERN
      common /error/ier
      common /para/alp,mu2,fm
      common /nfl/nf
      DATA alpi,gmu/   137.035999166d0,1.16637D-5/
      DATA ealpi,ergmu/000.000000037d0,0.00001D-5/
      data ml /0.510998910d-3,105.658367d-3,1.77682d0/
      data erml /0.000000013d-3,0.000004d-3,0.00016d0/
*     .. Executable Statements ..

c get number of flavors

      write (*,*) ' number of flavors: nf=2,3,4,5?'
      read (*,*) nf

      fm=0.1973269631d0         ! fermi in GeV^{-1}
      alp=1.d0/alpi
      mu2=ml(2)**2
      fac=4.d0*alp**2
      rt=1.0
      call hadrNECdist19(rt,rECgg,errstaECgg,errsysECgg)
      EPSABS = 0.0D0
      EPSREL = 1.0D-04
      A = 1.0D-6
      B = 27.3d0
      DO I=1,3
         IER=I 
         KOUNT = 0
         IFAIL = -1
*
         CALL D01AJF(FST,A,B,EPSABS,EPSREL,RESULT,
     &        ABSERR,W,LW,IW,LIW,IFAIL)
*
         RES(I)=RESULT*fac*1.d10*sqrt(mu2)/fm
      ENDDO
      WRITE (NOUT,*)
      WRITE (NOUT,99999) 'A      - lower limit of integration = ', A
      WRITE (NOUT,*) 'B      - upper limit of integration = infinity'
      WRITE (NOUT,99998) 'EPSABS - absolute accuracy requested = ',
     +  EPSABS
      WRITE (NOUT,99998) 'EPSREL - relative accuracy requested = ',
     +  EPSREL
      WRITE (NOUT,*)
      IF (IFAIL.NE.0) WRITE (NOUT,99996) 'IFAIL = ', IFAIL
      IF (IFAIL.LE.5) THEN
         WRITE (NOUT,99997) 'RESULT - approximation to the integral = ',
     +     RESULT
         WRITE (NOUT,99998) 'ABSERR - estimate of the absolute error = '
     +     , ABSERR
         WRITE (NOUT,99996) 'KOUNT  - number of function evaluations = '
     +     , KOUNT
         WRITE (NOUT,99996) 'IW(1)  - number of subintervals used = ',
     +     IW(1)
         write (NOUT,'(2x,3(2x,1pe11.4))') RES
      END IF
c      A=0.0d0
c      B=3.0d0
c      dt=(B-A)/100.
c       t=A
c      do i=1,100
c         t=t+dt
c         call hadrNECdist19(t,dECgg,derrstaECgg,derrsysECgg)
c         write (1,124) t,FST(t),ECLQCDKERN(t),dECgg
c      enddo 
c      call rewritedata()
      STOP
*
99999 FORMAT (1X,A,F10.4)
99998 FORMAT (1X,A,E9.2)
99997 FORMAT (1X,A,F9.5)
99996 FORMAT (1X,A,I4)
 124   format(1x,1pe15.8,4(2x,1pe13.6))
      END
*
      DOUBLE PRECISION FUNCTION FST(X)
      IMPLICIT NONE
*     .. Scalar Arguments ..
      DOUBLE PRECISION              X
*     .. Scalars in Common ..
      INTEGER                       KOUNT
*     .. Intrinsic Functions ..
*     .. Common blocks ..
      COMMON                        /TELNUM/KOUNT
*     .. Executable Statements ..
      integer IER
      real *8 FNT,dt,t1,dECgg,derrstaECgg,derrsysECgg,ECLQCDKERN
      common/error/ier
      common /tvar/t1
      EXTERNAL ECLQCDKERN
      KOUNT = KOUNT + 1
      t1=X
      dt=X
      call dhadrNECdist19(dt,dECgg,derrstaECgg,derrsysECgg)
      IF (IER.EQ.1) THEN
         FNT=ECLQCDKERN(dt)*dECgg
      ELSE IF (IER.EQ.2) THEN
         FNT=ECLQCDKERN(dt)*derrstaECgg
      ELSE IF (IER.EQ.3) THEN
         FNT=ECLQCDKERN(dt)*derrsysECgg
      ENDIF
      FST=FNT
      RETURN
      END
c
      subroutine hadrNECdist19(t,dECgg,errstaECgg,errsysECgg)
      IMPLICIT NONE
      INTEGER NB,IJ,I,ini,nf,ier
      PARAMETER(NB=401)
      real dEC(3)
      real null,t,dECgg,errstaECgg,errsysECgg
      double precision t1
      REAL TGG2(NB),YGG2(NB,3)
      COMMON /ECGG2/TGG2,YGG2
      REAL TGG3(NB),YGG3(NB,3)
      COMMON /ECGG3/TGG3,YGG3
      REAL TGG4(NB),YGG4(NB,3)
      COMMON /ECGG4/TGG4,YGG4
      REAL TGG5(NB),YGG5(NB,3)
      COMMON /ECGG5/TGG5,YGG5
      REAL TGG(NB),YGG(NB,3)
      COMMON /ECGG/TGG,YGG
      common /tvar/t1
      common /nfl/nf
      data ini/0/
      null=0.0
      t1=dble(t)

C initialize data

      if (nf.eq.5) then
         call ECgg5oftdata
         do i=1,NB 
            TGG(i)=TGG5(i)
            do ier=1,3 
               YGG(i,ier)=YGG5(i,ier)
            enddo
         enddo 
      else if (nf.eq.4) then
         call ECgg4oftdata
         do i=1,NB 
            TGG(i)=TGG4(i)
            do ier=1,3 
               YGG(i,ier)=YGG4(i,ier)
            enddo
         enddo 
      else if (nf.eq.3) then
         call ECgg3oftdata
         do i=1,NB 
            TGG(i)=TGG3(i)
            do ier=1,3 
               YGG(i,ier)=YGG3(i,ier)
            enddo
         enddo 
      else if (nf.eq.2) then
         call ECgg2oftdata
         do i=1,NB 
            TGG(i)=TGG2(i)
            do ier=1,3 
               YGG(i,ier)=YGG2(i,ier)
            enddo
         enddo
      else 
      endif

      if (t.lt.TGG(1)) then
        dECgg      =null
        errstaECgg=null
        errsysECgg=null
        return
      else if ((t.ge.TGG(1)).and.(t.le.TGG(NB))) then
        ij=NB
        do while (TGG(ij).gt.t)
          ij=ij-1
        enddo
        DO I=1,3
        dEC(i)=YGG(IJ,I)
     &    +(YGG(IJ+1,I)-YGG(IJ,I))/(TGG(IJ+1)-TGG(IJ))*(t-TGG(IJ))
        ENDDO
        dECgg     =dEC(1)
        errstaECgg=dEC(2)
        errsysECgg=dEC(3)
        return
      else 
        dECgg     =null
        errstaECgg=null
        errsysECgg=null
        if (ini.le.10) then
           write(*,*) ' out of range! t=',t
           ini=ini+1
           if (ini.eq.10) write(*,*) ' Warning: continuing anyway ...'
        endif
      endif
      return
      end

      subroutine dhadrNECdist19(dt,dECgg,derrstaECgg,derrsysECgg)
c Converts hadr5ECcdist17 to double precision variables in dhadr5ECcdist17
c
      implicit none
      real *8 dt,t1,dECgg,derrstaECgg,derrsysECgg
      real    st,sECgg,serrstaECgg,serrsysECgg
      common /tvar/t1
      t1=dt
      st=real(dt)
      call hadrNECdist19(st,sECgg,serrstaECgg,serrsysECgg)
      dECgg       =dble(sECgg)         
      derrstaECgg=dble(serrstaECgg) 
      derrsysECgg=dble(serrsysECgg)
      return
      end
c     
c Following datasets obtained with run parameters specified in the header
c
*      
      DOUBLE PRECISION FUNCTION integrandECLQCDKERN(e)
      IMPLICIT NONE
*     .. Scalar Arguments ..
      DOUBLE PRECISION  t,alp,mu2,fm,Q2,Z,XST,e,disc,x,f,sh,e0
*     .. Scalars in Common ..
      integer ier
*     .. Intrinsic Functions ..
*     .. Common blocks ..
      common /error/ier
      common /para/alp,mu2,fm
      common /tvar/t
*     .. Executable Statements ..
      Q2=e*e
      sh=Q2/mu2
      Z=(sqrt(sh**2+4.d0*sh)-sh)/sh/2.d0
      f=sh*Z**3*(1.d0-sh*Z)/(1.d0+sh*Z**2)/mu2
c      x=Q2/2.d0/mu2*(sqrt(1.d0+4.d0*mu2/Q2)-1.d0)
c      disc=x*(2.d0-x)/(1.d0-x)**2*mu2
c      Z=(sqrt(Q2**2+4.d0*mu2*Q2)-Q2)/(2.d0*mu2*Q2)
c      f=mu2*Q2*Z**3*(1.d0-Q2*Z)/(1.d0+mu2*Q2*Z**2)
      e0=fm/t
      XST=f*(Q2/e0**2-4.d0*(dsin(e/e0/2.d0))**2)/e*2.d0*e0**3/sqrt(mu2)
      integrandECLQCDKERN=XST
c dimensionless
      RETURN
      END
*
      DOUBLE PRECISION FUNCTION ECLQCDKERN(t)
      IMPLICIT NONE
*     D01AKF Example Program Text
*     Mark 14 Revised. NAG Copyright 1989.
*     .. Parameters ..
      INTEGER          LW, LIW
      PARAMETER        (LW=8000,LIW=LW/4)
      INTEGER          NOUT
      PARAMETER        (NOUT=6)
*     .. Scalars in Common ..
      INTEGER          KOUNT
*     .. Local Scalars ..
      DOUBLE PRECISION A, ABSERR, B, EPSABS, EPSREL, RESULT,
     &     RES,DA,ain,bin,t,t1
      INTEGER          IFAIL
*     .. Local Arrays ..
      DOUBLE PRECISION W(LW)
      INTEGER          IW(LIW)
*     .. External Functions ..
*     .. External Functions ..
      DOUBLE PRECISION integrandECLQCDKERN
      EXTERNAL         integrandECLQCDKERN
*     .. External Subroutines ..
      EXTERNAL         D01AKF
*     .. Common blocks ..
      COMMON           /TELNUM2/KOUNT
      integer ier,j
*     .. External Subroutines ..
*     .. Common blocks ..
      common /error/ier
      common /tvar/t1
      t1=t
*     .. Executable Statements ..
      EPSABS = 0.0D0
      EPSREL = 1.0D-03
      Ain=0.d0
      Bin=100.d0
      A=Ain
      B=Bin
      RESULT=0.D0
      KOUNT = 0
      DA=(B-A)/10.
      B=A+DA
      do j=1,10
         IFAIL = -1
*
*
         CALL D01AKF(integrandECLQCDKERN,A,B,EPSABS,EPSREL,RES,
     &        ABSERR,W,LW,IW,LIW,IFAIL)
*
         RESULT=RESULT+RES
         A=A+DA
         B=B+DA
      enddo
      ECLQCDKERN=result
c dimensionless
      RETURN
      END

      subroutine rewritedata()
      IMPLICIT NONE
      character*5 xxx,yyy
      INTEGER nf,NB,IJ,I,irever,icount,NP,ISCAN,UNIT
      PARAMETER(NB=401)
      REAL TGG(NB),YGG(NB,3)
      real*8 XV(3000),YV(3000),ZV(3000),UV(3000)
      real*8 X(3000),Y(3000,3)
      COMMON /ECGG/TGG,YGG
      CHARACTER*78 TEXT(20)
      INTEGER K,NCOM,NCURF,NSF
      REAL ANZCOM,ANZCUR,NUM
      common /nfl/nf

C initialize data

c      call ECgg5oftdata
c
c      do i=1,NB 
c         icount=i
c         irever=NB-i+1
c         XV(irever)=TGG5(icount)
c         YV(irever)=YGG5(icount,1)
c         ZV(irever)=YGG5(icount,2)
c         UV(irever)=YGG5(icount,3)
c      enddo
      K=8
      OPEN(UNIT=K,FILE='./dat/ECgg5log_ext.dap',STATUS='OLD')
C
C Get data from DATA-FILE
C
      READ(K,9) ANZCOM
      READ(K,9) ANZCUR
      READ(K,9) NUM
      NCOM=NINT(ANZCOM)
      NCURF=NINT(ANZCUR)
      NSF=NINT(NUM)
      IF (NCOM.GT.2) THEN
         DO I=1,NCOM-2
            READ(K,*) TEXT(I)
         ENDDO
      ENDIF
      write (*,*) NCOM,NCURF,NSF
      write (9,*) '      2.00000'
      write (9,*) '      1.00000'
      write (9,*) '   ',float(nsf)
      DO I=1,NSF
C Read data
         READ(K,*,END=300,ERR=301) X(I),Y(I,1),Y(I,2),Y(I,3)
         write (9,98) X(I),Y(I,1),Y(I,2),Y(I,3)
         icount=i
         irever=NSF-i+1
         XV(irever)=X(icount)
         YV(irever)=Y(icount,1)
         ZV(irever)=Y(icount,2)
         UV(irever)=Y(icount,3)
      ENDDO
 300  GOTO 302
 301  PRINT *,' ERROR IN READING THE DATA '
 302  CONTINUE
      close(K)
C end reading data
      UNIT=7

c      IF (NFL.EQ.3) THEN
c         write (7,*) '      subroutine ECgg3'
c         write (7,*) '      IMPLICIT NONE'
c         write (7,*) '      INTEGER NB,I,J'
c         write (7,*) '      PARAMETER(NB=400)'
c         write (7,*) '      REAL TGG3(NB),YGG3(NB,3)'
c         write (7,*) '      COMMON /ECGG3/TGG3,YGG3'
c      ELSE IF (NFL.EQ.4) THEN
c         write (7,*) '      subroutine ECgg4'
c         write (7,*) '      IMPLICIT NONE'
c         write (7,*) '      INTEGER NB,I,J'
c         write (7,*) '      PARAMETER(NB=400)'
c         write (7,*) '      REAL TGG4(NB),YGG4(NB,3)'
c         write (7,*) '      COMMON /ECGG4/TGG4,YGG4'
c      ELSE
         write (UNIT,*) '      subroutine ECgg5'
         write (UNIT,*) '      IMPLICIT NONE'
         write (UNIT,*) '      INTEGER NB,I,J'
         write (UNIT,*) '      PARAMETER(NB=400)'
         write (UNIT,*) '      REAL TGG5(NB),YGG5(NB,3)'
         write (UNIT,*) '      COMMON /ECGG5/TGG5,YGG5'
c      ENDIF
c      IF (NFL.EQ.3) THEN
c         xxx='TGG3 '
c         yyy='YGG3 '
c      ELSE IF (NFL.EQ.4) THEN
c         xxx='TGG4 '
c         yyy='YGG4 '
c      ELSE
         xxx='TGG5 '
         yyy='YGG5 '
c      ENDIF
      DO I=1,NCOM-2
         write (UNIT,'(78(A))') TEXT(I)
      ENDDO
      NP=NB
      ISCAN=2
      call printscan(UNIT,XV,YV,ZV,UV,NP,ISCAN,xxx,yyy)
      write (*,*) ' plot data written fort.9'
      write (*,*) ' reordered data file written fort.7'
  9   FORMAT(1X,F12.3)
 10   format(1x,1pe11.4,3(2x,1pe11.4))
 98   format(1x,1pe15.8,4(2x,1pe13.6))
      return
      end
      
      include 'ECgg5oft19.f'

      save
      RETURN
      END
      include 'ECgg4oft19.f'

      save
      RETURN
      END
      include 'ECgg3oft19.f'

      save
      RETURN
      END
      include 'ECgg2oft19.f'

      save
      RETURN
      END
