C
       FUNCTION BWINT(X,MR,GR,PR,A,B)
C      ------------------------------
C INTEGRAL OF BW-RESONANCE (analityc form for delta r )
C non-relativistic form prop to G^2*P/[(E-M)^2+G^2/4]
C first form in F.J., Rheinsberg Proc.:
C F. Jegerlehner, hep-ph/9606484 ; Nucl. Phys. (Proc. Suppl.) 51C (1996) 131
       IMPLICITREAL*8(A-Z)
       integer irennew
       common /rennew/irennew
       E=mr*1.d-3
       reno1=1.d0
       reno2=1.d0
       if (irennew.eq.-1) then
          reno=1.d0
       else
          CALL RENORMALIZE2(E,reno1,reno2)
          if (irennew.eq.0) reno2=1.d0
          reno=reno1*reno2
       endif
       BWINT=BWINC(X,MR,GR,PR,A,B)-BWINC(0.D0,MR,GR,PR,A,B)
CC Subtract electromagnetic decay channels: correction XP
C       MX=MR
C       IF (MX.GT.1.D2) MX=MX*1.D-3
C       SR=MX**2
C       if (MX.LT.3.6D0) then
C         RL=2.d0
C       else
C         RL=3.d0
C       endif
CC       XP=1.D0-(RL+RS(SR))*PR
C       XP=1.D0-(RL)*PR
       XP=1.D0
       BWINT=BWINT*reno*XP
C       write(*,*) MX,XP
       RETURN
       END
C
       FUNCTION BWINC(Q,MR,GR,PR,A,B)
C      ------------------------------
C auxiliary function for NR BW intergration by BWINT
       IMPLICITREAL*8(A-Z)
       COMPLEX*16 I,CDLOG,RES,CO1,CO2,CO3,BMM,AMM,BMP,AMP,BMR,AMR,
     .  RMM,RESU,FIN,DCMPLX,DCONJG
       EPS=1.D-8
       C=GR/2D0
       X=0.D0
       IF (Q.GT.0.D0) X=Q
       Y=0.D0
       IF (Q.LT.0.D0) Y=-Q
        I =DCMPLX(0.D0,1.D0)
       CO1=DCMPLX(X-MR,Y-C)
       CO2=DCMPLX(X+MR,Y+C)
       CO3=DCMPLX(0.D0,2.D0*C)
       BMM=DCMPLX(B-X,-Y-EPS)
       AMM=DCMPLX(A-X,-Y-EPS)
       BMP=DCMPLX(B+X,Y+ EPS)
       AMP=DCMPLX(A+X,Y+ EPS)
       BMR=DCMPLX(B-MR,-C)
       AMR=DCMPLX(A-MR,-C)
       RMM=BMM/AMM
       IF (Q.GT.0)  RMM=DCMPLX(DABS((B-X)/(A-X)),0.D0)
       RES=(CDLOG(RMM)-CDLOG(BMR/AMR))/CO1
     .    +(CDLOG(BMR/AMR)-CDLOG(BMP/AMP))/CO2
       RESU=RES-DCONJG(RES)
       FIN=RESU/CO3
       BWINC=GR**2*PR*DREAL(FIN)
       RETURN
       END
C
       FUNCTION BWINF(Q,MR,GR,PR,A,B)
C      ------------------------------
C INTEGRAL OF BW-RESONANCE (analityc form for delta r )
C non-relativistic form prop to G^2*P/[(E-M)^2+G^2/4]
C equivalent second form
       IMPLICITREAL*8(A-Z)
       integer irennew
       common /rennew/irennew
       COMMON/NAWI/BWINF_NW
       E=mr*1.d-3
       reno1=1.d0
       reno2=1.d0
       if (irennew.eq.-1) then
          reno=1.d0
       else
          CALL RENORMALIZE2(E,reno1,reno2)
          if (irennew.eq.0) reno2=1.d0
          reno=reno1*reno2
       endif
       PI=4.D0*DATAN(1.D0)
       EPS=1.D-8
       C=GR/2D0
       M2=MR**2
       C2=C**2
       M2PC2=M2+C2
       IF (Q.GE.0.D0) S= Q**2
       IF (Q.LT.0.D0) S=-Q**2
       W=Q
       AUX1=S*(S-3.D0*M2+C2)/2.D0
       AUX2=(S+M2+C2)*M2PC2/2.D0
       AUX3=2.D0*MR*W*M2PC2/2.D0
       POLI=(S-M2+C2)**2+4.D0*M2*C2
       FAC1=M2/M2PC2/POLI
       FAC2=-GR/MR/2.D0
       TER1=(S*(S-M2+3.D0*C2))*(PI-DATAN(C/(B-MR))-DATAN(C/(MR-A)))
       TER2=AUX1*DLOG(((B-MR)**2+C2)/((MR-A)**2+C2))
     &     +AUX2*DLOG(DABS((B**2-S)/(A**2-S)))
       IF (Q.GE.0.D0) THEN
         TER3= AUX3*DLOG(DABS((B-W)/(A-W)))
         TER4=-AUX3*DLOG(DABS((B+W)/(A+W)))
       ELSE
         TER3= AUX3*2.D0*DATAN(W/B)
         TER4=-AUX3*2.D0*DATAN(W/A)
       ENDIF
       TER5=POLI*DLOG(A/B)
       BWINF   =-4.D0*GR*PR/MR*FAC1*(TER1+FAC2*(TER2+TER3+TER4+TER5))
     .           *reno
       BWINF_NW=-4.D0*GR*PR/MR*FAC1*S*(S-M2+3.D0*C2)*PI*reno
       RETURN
       END
C
       FUNCTION BWINZ(X,MR,GR,PR,AL,BL)
C      ------------------------------
C Integral of BW-Resonance (analityc form for delta r )
C Field theory form (Z-Resonance) fixed width
C as given in F.J., Rheinsberg Proc.:
       IMPLICITREAL*8(A-Z)
       integer irennew
       common /rennew/irennew
       E=mr*1.d-3
       reno1=1.d0
       reno2=1.d0
       if (irennew.eq.-1) then
          reno=1.d0
       else
          CALL RENORMALIZE2(E,reno1,reno2)
          if (irennew.eq.0) reno2=1.d0
          reno=reno1*reno2
       endif
       PI=4.D0*DATAN(1.D0)
       IF (X.GE.0.D0) THEN
         Q2= X**2
       ELSE
         Q2=-X**2
       ENDIF
       M2=MR**2
       G2=GR**2
       A =AL**2
       B =BL**2
       L1=DLOG(DABS((B-Q2)/(A-Q2)))
       L2=DLOG(((B-M2)**2+M2*G2)/((A-M2)**2+M2*G2))*0.5D0
       P1=DATAN(MR*GR/(B-M2))
       P2=DATAN(MR*GR/(M2-A))
       POLI=(Q2-M2)**2+M2*G2
       BWINZ=4.D0*Q2/M2*(Q2*(L1-L2)+(M2+G2-Q2)*MR/GR*(PI-P1-P2))
     & /POLI*G2*PR
CC Subtract electromagnetic decay channels: correction XP
C       MX=MR
C       IF (MX.GT.1.D2) MX=MX*1.D-3
C       SR=MX**2
C       if (MX.LT.3.6D0) then
C         RL=2.d0
C       else
C         RL=3.d0
C       endif
CC       XP=1.D0-(RL+RS(SR))*PR
C       XP=1.D0-(RL)*PR
       XP=1.D0
       BWINZ=BWINZ*reno*XP
C       write(*,*) MX,XP
       RETURN
       END
C
       FUNCTION DBWIZ(X,MR,GR,PR,AL,BL)
C ------------------------------
C Integral of BW-Resonance (analityc form for Adler function
C = s d/ds Delta alpha(s) )
C Field theory form (Z-Resonance) fixed width
       IMPLICITREAL*8(A-Z)
       integer irennew
       common /rennew/irennew
       E=mr*1.d-3
       reno1=1.d0
       reno2=1.d0
       if (irennew.eq.-1) then
          reno=1.d0
       else
          CALL RENORMALIZE2(E,reno1,reno2)
          if (irennew.eq.0) reno2=1.d0
          reno=reno1*reno2
       endif
       PI=4.D0*DATAN(1.D0)
       IF (X.GE.0.D0) THEN
         Q2= X**2
       ELSE
         Q2=-X**2
       ENDIF
       M2=MR**2
       G2=GR**2
       A =AL**2
       B =BL**2
       L1=DLOG(DABS((B-Q2)/(A-Q2)))
       L2=DLOG(((B-M2)**2+M2*G2)/((A-M2)**2+M2*G2))*0.5D0
       P1=DATAN(MR*GR/(B-M2))
       P2=DATAN(MR*GR/(M2-A))
       POLI=(Q2-M2)**2+M2*G2
       NORM=-4.D0*G2*PR*MR/GR/M2
       S =Q2
       DBWIZ=NORM*(
     &  S*((G2-M2)*S**2+(2*M2**2+2*G2*M2)*S-M2**3-2*G2*M2**2-G2**2*M2)*
     &       ((PI-P1-P2)-GR/MR*Q2/(Q2-M2-G2)*(L1-L2))/POLI**2
     & +Q2*(Q2-M2-G2)/POLI*GR/MR*Q2/(Q2-M2-G2)*
     &          ((M2+G2)/(Q2-M2-G2)*(L1-L2)+Q2*(A-B)/((Q2-B)*(Q2-A))))
C       s2=b
C       s1=a
C       a =(-4.d0/mr/gr*G2*PR)
C       b =PI-P1-P2
C       c =l2
C       g =gr/mr
C       t0= S*((S-M2-G2)*(B-G*S*(LOG(ABS(S2-S))-LOG(ABS(S1-S))-C)/(S-M2-G
C     1   2))/((S-M2)**2+G2*M2)+S*(B-G*S*(LOG(ABS(S2-S))-LOG(ABS(S1-S))-C
C     2   )/(S-M2-G2))/((S-M2)**2+G2*M2)-2*S*(S-M2)*(S-M2-G2)*(B-G*S*(LOG
C     3   (ABS(S2-S))-LOG(ABS(S1-S))-C)/(S-M2-G2))/((S-M2)**2+G2*M2)**2+S
C     4   *(S-M2-G2)*(-G*(LOG(ABS(S2-S))-LOG(ABS(S1-S))-C)/(S-M2-G2)+G*S*
C     5   (LOG(ABS(S2-S))-LOG(ABS(S1-S))-C)/(S-M2-G2)**2-G*S*(1/(S1-S)-1/
C     6   (S2-S))/(S-M2-G2))/((S-M2)**2+G2*M2))*A
C       b =PI
C       t1=S*((G2-M2)*S**2+(2*M2**2+2*G2*M2)*S-M2**3-2*G2*M2**2-G2**2*M2)
C     1   /((S-M2)**2+G2*M2)**2*A*B
C       t2=(-S*M2/(S-M2)**2)*A*B
C      write(*,*) ' DBWIZ-t0',(DBWIZ-t0)/DBWIZ
C      write(*,*) ' DBWIZ-t1',(DBWIZ-t1)/DBWIZ
C      write(*,*) ' DBWIZ-t2',(DBWIZ-t2)/DBWIZ
       XP=1.D0
       DBWIZ=DBWIZ*reno*XP
       RETURN
       END
C
       FUNCTION BWINX(X,MR,GR,PR,AL,BL)
C      ------------------------------
C      INTEGRAL OF BW-RESONANCE (analityc form for delta r )
C Field theory form (Z-Resonance)
       IMPLICITREAL*8(A-Z)
       integer irennew
       common /rennew/irennew
       E=mr*1.d-3
       reno1=1.d0
       reno2=1.d0
       if (irennew.eq.-1) then
          reno=1.d0
       else
          CALL RENORMALIZE2(E,reno1,reno2)
          if (irennew.eq.0) reno2=1.d0
          reno=reno1*reno2
       endif
       PI=4.D0*DATAN(1.D0)
       IF (X.GE.0.D0) THEN
         Q2= X**2
       ELSE
         Q2=-X**2
       ENDIF
       M2=MR**2
       G2=GR**2
       A =AL**2
       B =BL**2
       BWINX=4.D0*PR*G2*Q2/M2*((2*GR*M2*Q2*LOG(Q2-B)+SQRT(M2)*
     1   (2*M2*ATAN(M2**((-3.d0)/2.d0)*(M2**2-B*M2-B*G2)/GR)*Q2
     1   -2*M2**2*ATAN(M2**((-3.d0)/2.d0)*(M2**2-B*M2-B*G2)/GR))
     2   -GR*M2*LOG(M2**3-2*B*M2**2+B**2*M2+B**2*G2)*Q2)/
     3  ((2*GR*M2+2*GR**3)*Q2**2-4*GR*M2**2*Q2+2*GR*M2**3)-
     4   (2*GR*M2*Q2*LOG(Q2-A)+MR*
     4   (2*M2*ATAN(M2**((-3.d0)/2.d0)*(M2**2-A*M2-A*G2)/GR)*Q2
     5   -2*M2**2*ATAN(M2**((-3.d0)/2.d0)*(M2**2-A*M2-A*G2)/GR))
     6   -GR*M2*LOG(M2**3-2*A*M2**2+A**2*M2+A**2*G2)*
     7   Q2)/((2*GR*M2+2*GR**3)*Q2**2-4*GR*M2**2*Q2+2*GR*M2**3))
       BWINX=BWINX*reno
       RETURN
       END
C
       FUNCTION BWINZ_NW(X,MR,GR,PR,AL,BL)
C      ------------------------------
C      INTEGRAL OF BW-RESONANCE (analityc form for delta r )
C Field theory form (Z-Resonance); narrow width approximation
       IMPLICITREAL*8(A-Z)
       integer irennew
       common /rennew/irennew
       COMMON/NWAS/BWINZ_NWAS,BWINZ_NWAR
       E=mr*1.d-3
       reno1=1.d0
       reno2=1.d0
       if (irennew.eq.-1) then
          reno=1.d0
       else
          CALL RENORMALIZE2(E,reno1,reno2)
          if (irennew.eq.0) reno2=1.d0
          reno=reno1*reno2
       endif
       PI=4.D0*DATAN(1.D0)
       IF (X.GE.0.D0) THEN
         Q2= X**2
       ELSE
         Q2=-X**2
       ENDIF
       M2=MR**2
       G2=GR**2
       A =AL**2
       B =BL**2
       POLI=(Q2-M2)**2+M2*G2
       BWINZ_NW=4.D0*Q2/M2*(M2+G2-Q2)*MR/GR*PI/POLI*G2*PR*reno
C Large |Q2| approximation
       BWINZ_NWAS=-4.D0*PI*GR/MR*PR*reno
C zero width approximation
       BWINZ_NWAR=BWINZ_NWAS*Q2/(Q2-M2)*reno
       RETURN
       END
