#!/bin/csh -fx

if ("$1" == "") goto usage

set where = $1

echo " comparing files on directory " '$where' "with those on the current directory"

set SRC = ( \
	ACWMsin2theta.f \
	ECgg2oft19.f \
	ECgg3oft19.f \
	ECgg4oft19.f \
	ECgg5oft19.f \
	FSRfun.f \
	R330321.f \
	R3G0321.f \
	RGG0321.f \
	RGQCD4.f \
	RN20321.f \
	RS33_fit.f \
	RS33_fun.f \
	RS3G_fit.f \
	RS3G_fun.f \
	RSGG_fit.f \
	RSGG_fun.f \
	RSN2_fit.f \
	RSN2_fun.f \
	Rdat_all.f \
	Rdat_fit.f \
	Rdat_fun.f \
	RhighQ.f \
	alpha2SMc19.f \
	alphaQEDc19.f \
	alphaQEDcx_sub.f \
	alphaQEDr19.f \
	alphaQEDrx_sub.f \
	amuviaEC.f \
	arun.f \
	bwintana.f \
	bwintanalytic.f \
	cerrortot.f \
	cggvapx.f \
	chadr5n19.f \
	constants.f \
	constants_qcd.f \
	dggvapx.f \
	funalp2smcx.f \
	funalp2smrx.f \
	funalpqedcx.f \
	funalpqedrx.f \
	gm2had2.f \
	gm2had3.f \
	hadr5n03.f \
	hadr5n09.f \
	hadr5n19.f \
	hadr5x19.f \
	hadr5reson_ana.f \
	intRdatx.f \
	leptons.f \
	printdatarray.f \
	printscan.f \
	qcdpar2.f \
	renooldnew.f \
	renormalize2.f \
	renotab2.f \
	resonances_dat.f \
	resonances_renc.f \
	resonances_renr.f \
	rqcd-param.f \
	rqcd3.f \
	rqcd3m-ChK00.f \
	rqcd3m.f \
	rqcd3m_test.f \
	rqcdHS3x.f \
	rqcdHSn.f \
	spline3.f \
	test_R33dat.f \
	test_R3Gdat.f \
	test_RGGdat.f \
	test_RSN2.f \
	test_Rdat.f \
	testhadr5a.f \
	testhadr5x.f \
	vapotail.f \
	reso_reno.dat)


  foreach i ($SRC)
    if ( -r $i ) then
      tkdiff $i $where/$i &

	echo -n "Next file [y]/n?"
	set ans1=$<
	if ("$ans1" == "n") then
	exit 0
	else
      continue
    endif
  end

set INCFILES = ( \
	xRdat-extended.f \
	xRdat-nonres.f \
	xRdat-spacelikehigh.f \
	xnewAdler.f \
	Rdat_upd.f \
	dalhadshigh19_5.f \
	dalhadslow19_5.f \
	dalhadt19_5.f \
	dalhadthigh19_5.f \
	deghadshigh19_5.f \
	deghadslow19_5.f \
	deghadt19_5.f \
	deghadthigh19_5.f \
	fit1dp.f \
	hadrK3cdist19.f \
	k3chadslow19.f \
	common.h \
	epem33fit079081.h \
	epem33fit0814new.h \
	epem33fit1425.h \
	epem3gfit079081.h \
	epem3gfit0814new.h \
	epem3gfit1425.h \
	epemfit079081.h \
	epemfit0814new.h \
	epemfit1432.h \
	epemfit32cut.h \
	epemggfit079081.h \
	epemggfit0814new.h \
	epemggfit1425.h \
	epemn2fit079081.h \
	epemn2fit0814new.h \
	epemn2fit1425.h \
	ffppg2fit0810.h \
	ffppmfit0810.h \
	r33fitrhohig.h \
	r33fitrholow.h \
	r3gfitrhohig.h \
	r3gfitrholow.h \
	rfitrhohig.h \
	rfitrholow.h \
	rggfitrhohig.h \
	rggfitrholow.h \
	rn2fitrhohig.h \
	rn2fitrholow.h)


  foreach i ($INCFILES)
    if ( -r $i ) then
      tkdiff $i $where/$i &

	echo -n "Next file [y]/n?"
	set ans1=$<
	if ("$ans1" == "n") then
	exit 0
	else
      continue
    endif
  end

set SHELLSCRIPTS = ( \
	ECintR.sh \
	alphaQEDc19.sh \
	alphaQEDc19_gnu.sh \
	compare.sh \
	intRdatx.sh \
	intRdatx_clean.sh \
	test_Rdat.sh \
	test_Rdat_gnu.sh)

  foreach i ($SHELLSCRIPTS)
    if ( -r $i ) then
      tkdiff $i $where/$i &

	echo -n "Next file [y]/n?"
	set ans1=$<
	if ("$ans1" == "n") then
	exit 0
	else
      continue
    endif
  end

exit 0
usage:
echo "Usage: compare dir"
echo "where dir contains the files to be compared"
echo "next tkdiff window enter q for [quit] "
exit 2
