C**************************FIT1*******************************
C     LINEAR LEAST SQUARES FIT
C
      SUBROUTINE FIT1(X,Y,SIG,NDAT,NPAR,A,SIGA,FCT,IUNIT,CHIOUT) 
      implicit real*8(a-h,o-z)
      PARAMETER(MAXPAR=10,MAXDAT=100,zero=0) 
      DIMENSION X(NDAT),Y(NDAT),SIG(NDAT),A(NPAR),SIGA(NPAR)
      DIMENSION V(MAXPAR,MAXPAR+1),VINV(MAXPAR,MAXPAR),WORK(3*MAXPAR)
      COMMON /COVFIT/ VINV
	EXTERNAL FCT
C+++++DOUBLE PRECISION V,DETERM 
C

      IF(NPAR.GT.MAXPAR)THEN
      WRITE(6,'('' ERROR IN FIT1: NPAR ='',I5)')NPAR
      RETURN
      ENDIF 
      DO I=1,NPAR
         A(I)=0. 
         SIGA(I)=0.
         DO J=1,NPAR+1
            V(I,J)=0.
         ENDDO
      ENDDO
      IF(NDAT.LT.NPAR)THEN
      WRITE(6,'('' ERROR IN FIT1: NDAT ='',I5)')NDAT
      RETURN
      ENDIF 
C
      DO K=1,NDAT
         DO I=1,NPAR
            A(I)=FCT(I,X(K))
            V(I,NPAR+1)=V(I,NPAR+1)+A(I)*Y(K)/SIG(K)**2
            DO J=1,I
               V(I,J)=V(I,J)+A(I)*A(J)/SIG(K)**2
               V(J,I)=V(I,J)
            ENDDO
         ENDDO
      ENDDO
C
cc      CALL MATIN1(V,MAXPAR,NPAR,DUMMY,1,INDEX,NERROR,DETERM)
      CALL MINV(V,VINV,NPAR,MAXPAR,ZERO,NERROR,WORK)
      IF(NERROR.NE.0)THEN
      WRITE(6,'('' ERROR IN FIT1: MATRIX INVERSION FAILED'')')
      RETURN
      ENDIF
C
      DO I=1,NPAR
         A(I)=ZERO
         DO J=1,NPAR
            A(I)=A(I)+VINV(I,J)*V(J,NPAR+1)
         ENDDO
         SIGA(I)=SQRT(VINV(I,I))
      ENDDO
C
      CHISQ=0.
      DO K=1,NDAT
         U=Y(K)
         DO I=1,NPAR
            U=U-A(I)*FCT(I,X(K))
         ENDDO
         CHISQ=CHISQ+(U/SIG(K))**2
      ENDDO
      IF(IUNIT.LE.0)RETURN
C
      WRITE(IUNIT,1000)NDAT,NPAR
1000  FORMAT(' LINEAR LEAST SQUARES FIT'/' NDAT =',I3/' NPAR =',I3)
      WRITE(IUNIT,1010)(I,A(I),SIGA(I),I=1,NPAR)
1010  FORMAT(/' FIT PARAMETERS:'/(' A(',I1,') =',E14.4,' +/-',E14.4)) 
	CHIOUT=CHISQ
      WRITE(IUNIT,1020)CHISQ
1020  FORMAT(/' CHI**2 =',F10.3)
      WRITE(IUNIT,'(/'' COVARIANCE MATRIX V(I,J):'')')
      DO 50 I=1,NPAR
      WRITE(IUNIT,1030)(VINV(I,J),J=1,NPAR)
1030  FORMAT(9E14.4)
50    CONTINUE
      END

C***********************MINV*********************************
C                                                  B.BUNK 1984
C     INVERSION OF A REAL,SYMMETRIC,POSITIV DEFINITE MATRIX 
C        (METHOD OF CONJUGATE GRADIENTS)
C 
C     A     : INPUT MATRIX
C     AINV  : INVERSE OF A (OUTPUT) 
C     N     : SIZE OF MATRICES A AND AINV 
C     NDIM  : FIRST DIMENSION OF A AND AINV IN CALLING PROGRAM
C     ERROR : BOUND ON LENGTH**2 OF RESIDUAL VECTOR 
C     NERROR: SET NONZERO IN CASE OF FAILURE
C     WORK  : REAL WORK VECTOR OF SIZE .GE. 3*N 
C 
C 
      SUBROUTINE MINV(A,AINV,N,NDIM,ERROR,NERROR,WORK) 
C 
      implicit real*8(a-h,o-z)
ccc      IMPLICIT REAL*8 (A-H,O-Z) 
C 
      DIMENSION A(NDIM,*),AINV(NDIM,*),WORK(*)
C 
ccc      REAL*8 A,AINV,WORK,ALPHA,BETA,ALAMB 
C 
      NERROR=0
C 
      DO I=1,N 
         DO J=1,N 
            AINV(I,J)=0.
         ENDDO
         AINV(I,I)=1.
      ENDDO
C 
C     START LOOP OVER COLUMNS OF AINV 
C 
      DO 100 M=1,N
C 
C     PREPARE FOR LOOP OVER ITERATIONS
C 
      ALPHA=0.
      DO 20 I=1,N 
      WORK(I)=AINV(I,M) - A(I,M)
      WORK(N+I)=WORK(I) 
      ALPHA=ALPHA + WORK(I)**2
20    CONTINUE
C 
      IF(ABS(ALPHA) .LE. ERROR)GOTO 100 
C 
C     START LOOP OVER ITERATIONS
C 
      DO 200 ITER=1,N+1 
C 
      ALAMB=0.
      DO I=1,N 
         K=2*N+I 
         WORK(K)=0.
         DO J=1,N 
            WORK(K)=WORK(K) + A(I,J)*WORK(J)
         ENDDO
         ALAMB=ALAMB + WORK(I)*WORK(K) 
      ENDDO
C 
      IF(ALAMB .EQ. 0.)THEN 
      NERROR=-M 
      RETURN
      ENDIF 
C   
      ALPHA=ALPHA/ALAMB 
C 
      BETA=0. 
      DO 40 I=1,N 
      AINV(I,M)=AINV(I,M) + ALPHA*WORK(I) 
      WORK(N+I)=WORK(N+I) - ALPHA*WORK(2*N+I) 
      BETA=BETA + WORK(N+I)*WORK(2*N+I) 
40    CONTINUE
      BETA=-BETA/ALAMB
C 
      ALPHA=0.
      DO 50 I=1,N 
      WORK(I)=BETA*WORK(I) + WORK(N+I)
      ALPHA=ALPHA + WORK(I)*WORK(N+I) 
50    CONTINUE
C 
      IF(ABS(ALPHA) .LE. ERROR)GOTO 100 
C 
200   CONTINUE
C 
100   CONTINUE
      END 
