c;;;;;;;;;;;;;;;;;;;;;;;;;;;;; -*- Mode: Fortran -*- ;;;;;;;;;;;;;;;;;;;;;;;;;;;
c;; funalp2smc.f --- 
c;; Author          : Friedrich Jegerlehner
c;; Created On      : Tue Feb 16 18:35:34 2010
c;; Last Modified By: Friedrich Jegerlehner
c;; Last Modified On: Tue Jul 18 13:15:58 2017
c;; RCS: $Id$
c;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
c;; Copyright (C) 2017 Friedrich Jegerlehner
c;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
c;; 
      function funalp2SMcx(s,cerror,cerrorsta,cerrorsys,
     &     contributionflag)
      implicit none
      character*3 contributionflag,Ismooth
      real*8 s,null,rerr,ierr
      double complex funalp2SMcx,cegvapx,cerror,cerrorsta,cerrorsys
      real*8 st2,als,mtop,alp2
      double complex cglept,cghadr,cgetop,cvpt_new,cvpt_hig,cvpt_low
      double complex alpha2c,alpha2h,alpha2l,alpha2ct,alpha2ht,alpha2lt,
     &     cDalpha2weak1MSb,
     &     cone,calp2,cerrdeg,cerrdegsta,cerrdegsys
      external cegvapx
********************* part to be included and edited in main program **************
c check cuts CHPTCUT,EC,ECUT   ! specify where to use CHPT and pQCD in constants_qcd
c decommment next line in main
c      double precision pi1,ALINP,ERRAL,EINP,MTOP1 ! get QCD parameters as set in constants_qcd
c QCD parameters required to calculare imaginary part (R) and top contribution 
      include 'common.h'      
c decomment next 3 lines in main
c      common/var1/pi1,ALINP,ERRAL,EINP,MTOP1
      common /parm/st2,als,mtop
c      COMMON/SMOO/Ismooth
      common /cesg/cglept,cghadr,cgetop,cDalpha2weak1MSb
c decomment next 2 lines in main
c      call constants()
c      call constants_qcd()
c      sin2ell=0.23153 ! pm 0.00016 LEPEEWG Phys Rep 427 (2006) 257
c decommment next line and change default as appropriate in main      
c      st2=0.23153d0   ! Reference value for weak mixing parameter
c decomment next 2 lines in main
c      als=ALINP       ! alpha strong
c      mtop=MTOP1      ! top quark mass
c      Ismooth=0       ! flag for imaginary part: 0= R(s) data; 1= R(s) fits
c following two entried set as default in chad5n09.f
c      IRESON=1        ! include narrow resonances in fits
c      iresonances=1   ! include narrow resonances in data sets
c decomment next line in main
c      call Rdata()
c decomment next line in main
c      call resonances_renocomplex()
cc      call resonances_renoreal()
C LEPTONflag=all,had,lep,ele,muo,tau -> iLEP=-3,-2,-1,1,2,3
C Default: 
C      LEPTONflag='all'
C      iLEP  = -3  ! for sum of leptons + quarks              
C decomment in main the following 2 lines for changing the default
c      LEPTONflag='all'   ! choose had,lep,top,ele,muo,tau
c      iLEP=LFLAG(LEPTONflag)
************************************************************************
      LEPTONflag=contributionflag
      iLEP=LFLAG(LEPTONflag)
c      
      alp2=alp/st2
      null=0.d0
      cone=DCMPLX(1.d0,null)
      calp2=DCMPLX(alp2,null)
c
      cvpt_new= cegvapx(s,cerrdeg,cerrdegsta,cerrdegsys)
      cvpt_hig= cvpt_new+cerrdeg
      cvpt_low= cvpt_new+cerrdeg
      alpha2c =calp2/(cone-cvpt_new)
      alpha2h =calp2/(cone-cvpt_hig)
      alpha2l =calp2/(cone-cvpt_low)
      alpha2ct=calp2/(cone-cvpt_new-cgetop-cDalpha2weak1MSb)
      alpha2ht=calp2/(cone-cvpt_hig-cgetop-cDalpha2weak1MSb)
      alpha2lt=calp2/(cone-cvpt_low-cgetop-cDalpha2weak1MSb)
      rerr=abs(DREAL(alpha2ht-alpha2lt))/2.d0
      ierr=abs(AIMAG(alpha2ht-alpha2lt))/2.d0
      cerror=DCMPLX(rerr,ierr)
      cerrorsta=alpha2c/calp2*alpha2c*cerrdegsta
      cerrorsys=alpha2c/calp2*alpha2c*cerrdegsys
      funalp2SMcx=alpha2ct
      return
      END
