c;;;;;;;;;;;;;;;;;;;;;;;;;;;;; -*- Mode: Fortran -*- ;;;;;;;;;;;;;;;;;;;;;;;;;;;
c;; funalpqed.f --- 
c;; Author          : Friedrich Jegerlehner
c;; Created On      : Sun Jan 17 05:35:18 2010
c;; Last Modified By: Friedrich Jegerlehner
c;; Last Modified On: Tue Jul 18 13:09:23 2017
c;; RCS: $Id$
c;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
c;; Copyright (C) 2010 Friedrich Jegerlehner
c;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
c;; 
      function funalpqedcx(s,cerror,cerrorsta,cerrorsys,
     &     contributionflag)
c calculating alpha complex of error cerror, statstical and systematic hadronic uncertainties in
c provided separately via cerrorsta,cerrorsys
      implicit none
      character*3 contributionflag
      double precision s,error,null,rerr,ierr
      double complex funalpqedcx,cerror,cerrorsta,cerrorsys
      double complex cggvapx,cerrder,cerrdersta,cerrdersys,
     &     calept,cahadr,caltop,cDalphaweak1MSb
      double complex cone,calp,cvpt_new,cvpt_hig,cvpt_low,alphac,alphah
     &     ,alphal,alphact,alphaht,alphalt
      external cggvapx
********************* part to be included and edited in main program **************
c check cuts CHPTCUT,EC,ECUT   ! specify where to use CHPT and pQCD in constants_qcd
c decommment next line in main
c      double precision pi1,ALINP,ERRAL,EINP,MTOP1 ! get QCD parameters as set in constants_qcd
c QCD parameters required to calculare imaginary part (R) and top contribution 
      include 'common.h'      
c decomment next 3 lines in main
c      common/var1/pi1,ALINP,ERRAL,EINP,MTOP1
c      common /parm/st2,als,mtop
c      COMMON/SMOO/Ismooth
c decomment next line if needed (provided also by cggvapx)
c      common /resu/dalept,dahadr,daltop,Dalphaweak1MSb   ! real results
      common /cres/calept,cahadr,caltop,cDalphaweak1MSb  ! complex results
c decomment next 2 lines in main
c      call constants()
c      call constants_qcd()
c      sin2ell=0.23153 ! pm 0.00016 LEPEEWG Phys Rep 427 (2006) 257
c decommment next line and change default as appropriate in main      
c      st2=0.23153d0   ! Reference value for weak mixing parameter
c decomment next 2 lines in main
c      als=ALINP       ! alpha strong
c      mtop=MTOP1      ! top quark mass
c      Ismooth=0       ! flag for imaginary part: 0= R(s) data; 1= R(s) fits
c following two entried set as default in chad5n17.f
c      IRESON=1        ! include narrow resonances in fits
c      iresonances=1   ! include narrow resonances in data sets
c decomment next line in main
c      call Rdata()
c decomment next line in main
c      call resonances_renocomplex()
cc      call resonances_renoreal()
C LEPTONflag=all,had,lep,ele,muo,tau -> iLEP=-3,-2,-1,1,2,3
C Default: 
C      LEPTONflag='all'
C      iLEP  = -3  ! for sum of leptons + quarks              
C decomment in main the following 2 lines for changing the default
c      LEPTONflag='all'   ! choose had,lep,top,ele,muo,tau
c      iLEP=LFLAG(LEPTONflag)
************************************************************************
      LEPTONflag=contributionflag
      iLEP=LFLAG(LEPTONflag)
c
      null=0.d0
      cone=DCMPLX(1.d0,null)
      calp=DCMPLX(alp,null)
c
      cvpt_new= cggvapx(s,cerrder,cerrdersta,cerrdersys)
      cvpt_hig= cvpt_new+cerrder
      cvpt_low= cvpt_new-cerrder
c
      alphac =calp/(cone-cvpt_new)
      alphah =calp/(cone-cvpt_hig)
      alphal =calp/(cone-cvpt_low)
      alphact=calp/(cone-cvpt_new-caltop-cDalphaweak1MSb)
      alphaht=calp/(cone-cvpt_hig-caltop-cDalphaweak1MSb)
      alphalt=calp/(cone-cvpt_low-caltop-cDalphaweak1MSb)
      rerr=abs(DREAL(alphaht-alphalt))/2.d0
      ierr=abs(AIMAG(alphaht-alphalt))/2.d0
      cerror=DCMPLX(rerr,ierr)
      cerrorsta=alphac/calp*alphac*cerrdersta
      cerrorsys=alphac/calp*alphac*cerrdersys
      funalpqedcx=alphact
      return
      END
