C
      subroutine hadr5reson_ana(E,RES,STA,SYS,STA2,SYS2)
c calculate resonance contributions from rho, omega, phi, Psi(i), i=1,2,3 and Yps (i) i=1,2,3,4,5,6
c analytically
      IMPLICIT NONE
      CHARACTER *3 LEPTONflag1
      INTEGER     LW,       LIW
      PARAMETER  (LW=320000,LIW=LW/4)
      INTEGER IFAIL,KOUNT,IW(LIW)
      REAL *8 W(LW)
      INTEGER J,IKE,IPV,IREN,IRENO,NP,NPS,NYP,IPV_SAV
      REAL *8 PI1,ALP2,FBW,GBW,UMG,UGM,UMG2,UGM2,E,STA2,SYS2,NULL
      REAL *8 MRO,MOM,MFI,GRO,GOM,GFI,PRO,POM,PFI
      REAL*8 PSI(6),MPS(6),GPS(6),PPS(6),YPI(6),MYP(6),GYP(6),PYP(6)
      REAL*8 STAPS(6),SYSPS(6),STAYP(6),SYSYP(6)
      REAL*8 FSTA(5),FSYS(5),RES(6),STA(6),SYS(6)
      real *8 st2,als,mtop,dalept,dahadr,daltop
      REAL *8 me,ME2,COSTHETA,FA,MPLUS,MP2,M2,M3,A,B,AL,BL,
     &     EOMMIN,EOMMAX,EFIMIN,EFIMAX,ROREI,OMREI,FIREI,EPSREL,RESULT,
     &     ABSERR,RESNUM,BWINZ,BWINT,DBWIZ,RX,MM,GG,FACT,RESULT1
      double precision pi3,ALINP,ERRAL,EINP,MTOP1
      REAL*8 EMIPS(6),EMAPS(6),EMIYP(6),EMAYP(6),EOMM,EOMP,EFIM,EFIP
      REAL *8 BWM,BWG,BWP,PSINWA(6),YPINWA(6)
      REAL *8 XX0,ST0,SY0,EPPMIN,EPPMAX,ACUT,BCUT
c,XX1,ST1,SY1,XX2,ST2,SY2
      integer irennew,iopt,iso
      common /rennew/irennew
      common /BWPAR/BWM,BWG,BWP
      COMMON/RESDOMAINS/EMIPS,EMAPS,EMIYP,EMAYP,EOMM,EOMP,EFIM,EFIP
      EXTERNAL ROREI,OMREI,FIREI,BWREI,FACT,BWINZ,BWINT,DBWIZ
***************** part to be included also in main program **************
       include 'common.h'
       common /parm/st2,als,mtop
       common /resu/dalept,dahadr,daltop
       common /rhowidth/iopt,iso
       COMMON/FFF/IKE,IPV,IREN,IRENO
C Parameters for this routine: LEPTONflag1 only switches between ele and lem=ele+muo
       COMMON/BHAB/ME2,COSTHETA,LEPTONflag1
       COMMON/MFPI/MP2,M2
       COMMON/MMP/MPLUS,EPPMIN,EPPMAX
       COMMON/BWRO/MRO,GRO,PRO/BWOM/MOM,GOM,POM/BWFI/MFI,GFI,PFI
       COMMON/CSTS/PI1,ALP2,FA
C cpmmon Psi and Upsilon parameters set in subroutine resonances
       COMMON/PSYPPAR/MPS,GPS,PPS,MYP,GYP,PYP,STAPS,SYSPS,STAYP,SYSYP
       COMMON/RESRELERR/FSTA,FSYS
       common/var1/pi3,ALINP,ERRAL,EINP,MTOP1
       COMMON /NAGRELERR/EPSREL
       COMMON /NWA/PSI,PSINWA,YPI,YPINWA
       NULL=0.d0
       call constants()
       call constants_qcd()     ! fills commons var and RCUTS
c     sin2ell=0.23153 ! pm 0.00016 LEPEEWG Phys Rep 427 (2006) 257
       st2=0.23153d0            ! Reference value for weak mixing parameter
       als=ALINP                ! alpha strong
       mtop=MTOP1               ! top quark mass
       me=ml(1)
       me2=me*me
       COSTHETA=0.6D0
       LEPTONflag1='ele'
C LEPTONflag=all,had,lep,ele,muo,tau,lem -> iLEP=-3,-2,-1,1,2,3,4
C Some VP subtractuions only include the electron = ele or electron plus muon = lem
C Default:
C      LEPTONflag='all'
C      iLEP  = -3  ! for sum of leptons + quarks
C Decomment in main the folowwing line for changing the default
c      LEPTONflag='all'   ! choose had,lep,top,ele,muo,tau,lem
************************************************************************
c Set parameters in above common blocks: BWOM,BWFI,PSYPPAR, RESRELERR
c rho, omega, phi, J/psi and Upsilon series
c
       call resonances_data()
c
c called from ..../for/vap/qed/resonances_dat.f
************************************************************************
c
      UMG=1.D-3                 ! convert MeV into GeV
      UGM=1.D3                  ! convert GeV into MeV
      UMG2=1.D-6
      UGM2=1.D6
      MPLUS=139.56995D0
      MP2=MPLUS**2
c
C conversion of Breit-Wigner FUNCTION BW() to R!
      FBW=(3.D0/2.D0/ALP1)**2
      ALP2=ALP1
C conversion R to Adler
      GBW=4.D0*PI1*FBW
      M2=E*ABS(E)*UGM2
      do j=1,6
         res(j)=NULL
         sta(j)=NULL
         sys(j)=NULL
         PSI(j)   =NULL
         PSINWA(j)=NULL
         YPI(j)   =NULL
         YPINWA(j)=NULL
      enddo
      IPV_SAV=IPV
C rho is not included as a narrow width resonance
C Here we need it to calculate the I=0 part to be subtracted in the SU(2) coupling
C need omega region only
      IFAIL=0
      EPPMIN=695.d0
      EPPMAX=880.d0
      A=EPPMIN**2
      B=EPPMAX**2
      iopt=11
      iso=0
      RES(1)=BWINZ(M3,MRO,GRO,PRO,AL,BL)*FA*FBW
      XX0=RES(1)
      RX=DABS(XX0)
      ST0=FSTA(1)*RX
      SY0=FSYS(1)*RX
      RES(1)=XX0
      STA(1)=ST0
      SYS(1)=SY0
C      *******************
C      OMEGA,PHI BW-Resonances
C Normalization factor:
C FA*FBW is -3/(16*pi^2*alpha^2)*1000(scale factor) if multiplied by
C e^2=4 pi alpha we have   -3/(4*pi*alpha)*1000. The narrow width contribution
C to "Re Pi_had" is FA*FBW*4*pi*GR*PR/MR/1000
C Assume widths quoted by PDG are the physical widths ->
C apply factor reno=(alpha/alpha(s))**2 -> (IREN=2 means full vapo subtraction)
      IFAIL=0
      IRENO=-1
      IREN=2                    ! with physical (dressed) width from PDG
      irennew=0  ! for resonance integration assuming physical widths
      M3=E*UGM
      AL=3.D0*MPLUS
      IF (M3.LE.AL.AND.M3.GT.AL-5.D0*GOM) AL=AL+5.D0*GOM
      IF (M3.GT.AL.AND.M3.LT.AL+5.D0*GOM) AL=AL-5.D0*GOM
      BL=0.81D3
      IF (ABS(M3-BL).LT.2.5D2) BL=BL+5.0D2
      EOMMIN=AL
      EOMMAX=BL
      A =AL**2
      B =BL**2
      RES(2)=BWINZ(M3,MOM,GOM,POM,AL,BL)*FA*FBW
      RX=ABS(RES(2))
      STA(2)=FSTA(2)*RX
      SYS(2)=FSYS(2)*RX
      STA2=STA2+STA(2)**2
      SYS2=SYS2+SYS(2)**2
c Phi
      EFIMIN=1.00D3
      EFIMAX=1.04D3
      AL=EFIMIN
      BL=EFIMAX
      A =AL**2
      B =BL**2
      RES(3)=BWINZ(M3,MFI,GFI,PFI,AL,BL)*FA*FBW
      RX=ABS(RES(3))
      STA(3)=FSTA(3)*RX
      SYS(3)=FSYS(3)*RX
      STA2=STA2+STA(3)**2
      SYS2=SYS2+SYS(3)**2
C     PSI-FAMILY   NARROW WIDTH
      AL=3.D3
      IF (ABS(M3-AL).LT.0.5D3) AL=2.D3
      BL=5.D3
      IF (ABS(M3-BL).LT.1.0D3) BL=7.D3
      DO NPS=1,3
         BWM=MPS(NPS)
         BWG=GPS(NPS)
         BWP=PPS(NPS)
         A=EMIPS(NPS)**2*UGM2
         B=EMAPS(NPS)**2*UGM2
         PSI(NPS)=BWINZ(M3,MPS(NPS),GPS(NPS),PPS(NPS),AL,BL)*FA*FBW
         STA(4)=SQRT(STA(4)**2+(ABS(PSI(NPS))*STAPS(NPS))**2)
         SYS(4)=SQRT(SYS(4)**2+(ABS(PSI(NPS))*SYSPS(NPS))**2)
      ENDDO
      RES(4)=PSI(1)+PSI(2)+PSI(3)
      STA2=STA2+STA(4)**2
      SYS2=SYS2+SYS(4)**2
C     YPSILON-FAMILY   NARROW WIDTH
      AL=9.D3
      IF (ABS(M3-AL).LT.0.5D3) AL=8.D3
      BL=12.D3
      IF (ABS(M3-BL).LT.1.0D3) BL=14.D3
      DO NYP=1,6
         BWM=MYP(NYP)
         BWG=GYP(NYP)
         BWP=PYP(NYP)
         A=EMIYP(NYP)**2*UGM2
         B=EMAYP(NYP)**2*UGM2
         YPI(NYP)=BWINZ(M3,MYP(NYP),GYP(NYP),PYP(NYP),AL,BL)*FA*FBW
         STA(5)=SQRT(STA(5)**2+(ABS(YPI(NYP))*STAYP(NYP))**2)
         SYS(5)=SQRT(SYS(5)**2+(ABS(YPI(NYP))*SYSYP(NYP))**2)
      ENDDO
      RES(5)=YPI(1)+YPI(2)+YPI(3)+YPI(4)+YPI(5)+YPI(6)
      STA2=STA2+STA(5)**2
      SYS2=SYS2+SYS(5)**2
      IPV=IPV_SAV
      RETURN
99996 FORMAT (1X,A,I4)
      END
