#!/bin/csh -fx
if ("$1" == "") goto usage

set year='19'

set datum = `date +"%D"`

#if ( -r iRdcount ) then
#  set count = `cat iRdcount`
#  if ( $count == 0 ) then
#     set count = 1
#  endif
#else
#  set count = 0
#endif
#  echo $count
#if ( -r intRdatx.tab ) then
#  set count = `expr $count + 1` 
#  echo $count
#  rm -f iRdcount
#  echo $count > iRdcount

  set DAT_FILES=( intRdatx_gg_check.dap intRdatx_n2.dap \
		intRdatx.tab dalhads.dat flavors.dat intRdatx.dap intRdatx_gg.dap intRdatx_3g.dap intRdatx_33.dap)

  set GGPLOT_FILES=( intRdatx_n3.dap intRdatx_n4.dap intRdatx_n5.dap)

  set G3PLOT_FILES=( intRdatg3_n3.dap intRdatg3_n4.dap intRdatg3_n5.dap)

echo $DAT_FILES

  foreach i ($DAT_FILES)
    if ( -r $i ) then
#      mv $i $i';'$count
#      rm -f $i 
      mv $i $i'_sav'
      continue
    endif
  end
  foreach i ($GGPLOT_FILES)
    if ( -r $i ) then
#      mv $i $i';'$count
#      rm -f $i 
      mv $i $i'_sav'
      continue
    endif
  end
  foreach i ($G3PLOT_FILES)
    if ( -r $i ) then
#      mv $i $i';'$count
#      rm -f $i 
      mv $i $i'_sav'
      continue
    endif
  end
#endif

  set KIL_FILES=(EClabel \
		intRdatx.dat intRdatx_gg.dat intRdatx_3g.dat intRdatx_33.dat)

  foreach i ($KIL_FILES)
    if ( -r $i ) then
      rm -f $i 
      continue
    endif
  end

#  set SAV_FILES=( fort.80 fort.81 fort.82 fort.83 fort.89 \
#		fort.16 fort.17 fort.51 fort.57 fort.84 fort.85 fort.86 fort.87 fort.88 fort.90 fort.97 fort.99)
#
#  foreach i ($SAV_FILES)
#    if ( -r $i ) then
#      cp $i $i'sav'
#      continue
#    endif
#  end

make -f Makefile_iRdx

if ("$1" == "0") then 
#rm -f EClabel
echo ' running  intRdatx < intRdatx.inp'
time ./intRdatx < intRdatx.inp
if ( -r EClabel ) then
  set nf = `cat EClabel`
    if ("$nf" == "") then
       echo ' for results see dalhads.dat'
    else	 
      set file = 'ECgg'$nf'oft'$year'.f'
      cp dalhads.dat $file
    endif
else
endif
exit
endif
if ("$1" == "1") then 
cat intRdat.inp0 > intRdatx.inp$1
cat >> intRdatx.inp$1 <<_EOF_
1,0
# -01- hadr5n time-like low der
_EOF_
set name = dalhadslow$year
echo "\
c      ++++ ""$name"" ++++  " > $name.f
echo "\
c update $datum " >> $name.f
endif
if ("$1" == "2") then 
  foreach i ($GGPLOT_FILES)
    if ( -r $i ) then
      mv $i $i'_sav'
      continue
    endif
  end
if ("$2" == "") then 
cat intRdat.inp0 > intRdatx.inp$1
cat >> intRdatx.inp$1 <<_EOF_
-1,0
# -02- hadr5n space-like der
_EOF_
else
cat intRdat.inp1 > intRdatx.inp$1
cat >> intRdatx.inp$1 <<_EOF_
-1,0,$2
# -02- hadr5n space-like der
_EOF_
endif
set name = dalhadt$year
echo "\
c      ++++ ""$name"" ++++  " > $name.f
echo "\
c update $datum " >> $name.f
endif
if ("$1" == "3") then 
cat intRdat.inp0 > intRdatx.inp$1
cat >> intRdatx.inp$1 <<_EOF_
2,0
# -03- hadr5n time-like high der
_EOF_
set name = dalhadshigh$year
echo "\
c      ++++ ""$name"" ++++  " > $name.f
echo "\
c update $datum " >> $name.f
endif

if ("$1" == "4") then 
cat intRdat.inp0 > intRdatx.inp$1
cat >> intRdatx.inp$1 <<_EOF_
1,2
# -04- hadr5n time-like low deg
_EOF_
set name = deghadslow$year
echo "\
c      ++++ ""$name"" ++++  " > $name.f
echo "\
c update $datum " >> $name.f
endif
if ("$1" == "5") then 
  foreach i ($G3PLOT_FILES)
    if ( -r $i ) then
      mv $i $i'_sav'
      continue
    endif
  end
if ("$2" == "") then 
cat intRdat.inp0 > intRdatx.inp$1
cat >> intRdatx.inp$1 <<_EOF_
-1,2
# -02- hadr5n space-like der
_EOF_
else
cat intRdat.inp1 > intRdatx.inp$1
cat >> intRdatx.inp$1 <<_EOF_
-1,2,$2
# -02- hadr5n space-like der
_EOF_
endif
set name = deghadt$year
echo "\
c      ++++ ""$name"" ++++  " > $name.f
echo "\
c update $datum " >> $name.f
endif
if ("$1" == "6") then 
cat intRdat.inp0 > intRdatx.inp$1
cat >> intRdatx.inp$1 <<_EOF_
2,2
# -06- hadr5n time-like high deg
_EOF_
set name = deghadshigh$year
echo "\
c      ++++ ""$name"" ++++  " > $name.f
echo "\
c update $datum " >> $name.f
endif

if ("$1" == "7") then 
cat intRdat.inp0 > intRdatx.inp$1
cat >> intRdatx.inp$1 <<_EOF_
1,4
# -07- hadr5n time-like low deg3
_EOF_
set name = de3hadslow$year
echo "\
c      ++++ ""$name"" ++++  " > $name.f
echo "\
c update $datum " >> $name.f
endif
if ("$1" == "8") then 
cat intRdat.inp0 > intRdatx.inp$1
cat >> intRdatx.inp$1 <<_EOF_
-1,4
# -08- hadr5n space-like deg3
_EOF_
set name = de3hadt$year
echo "\
c      ++++ ""$name"" ++++  " > $name.f
echo "\
c update $datum " >> $name.f
endif
if ("$1" == "9") then 
cat intRdat.inp0 > intRdatx.inp$1
cat >> intRdatx.inp$1 <<_EOF_
2,4
# -09- hadr5n time-like high deg3
_EOF_
set name = de3hadshigh$year
echo "\
c      ++++ ""$name"" ++++  " > $name.f
echo "\
c update $datum " >> $name.f
endif
if ("$1" == "10") then 
cat intRdat.inp10 > intRdatx.inp$1
set name = k3chadslow$year
echo "\
c      ++++ ""$name"" ++++  " > $name.f
echo "\
c update $datum " >> $name.f
endif
if ("$1" == "14") then 
cat intRdat.inp12 > intRdatx.inp$1
cat >> intRdatx.inp$1 <<_EOF_
0,1
# -12-1- second integral of amuhad(K3c)
_EOF_
set name = k3chadres$year
endif
if ("$1" == "15") then 
cat intRdat.inp12 > intRdatx.inp$1
cat >> intRdatx.inp$1 <<_EOF_
0,3
# -12-2- second integral of amuhad(K3c) error
_EOF_
set name = k3chaderr$year
endif
if ("$1" == "11") then 
cat intRdat.inp0 > intRdatx.inp$1
cat >> intRdatx.inp$1 <<_EOF_
-2,0
# -11- hadr5n space-like high der
_EOF_
set name = dalhadthigh$year
echo "\
c      ++++ ""$name"" ++++  " > $name.f
echo "\
c update $datum " >> $name.f
endif
if ("$1" == "12") then 
cat intRdat.inp0 > intRdatx.inp$1
cat >> intRdatx.inp$1 <<_EOF_
-2,2
# -12- hadr5n space-like high deg
_EOF_
set name = deghadthigh$year
echo "\
c      ++++ ""$name"" ++++  " > $name.f
echo "\
c update $datum " >> $name.f
endif
if ("$1" == "13") then 
cat intRdat.inp0 > intRdatx.inp$1
cat >> intRdatx.inp$1 <<_EOF_
-2,4
# -13- hadr5n space-like high de3
_EOF_
set name = de3hadthigh$year
echo "\
c      ++++ ""$name"" ++++  " > $name.f
echo "\
c update $datum " >> $name.f
endif

echo ' run intRdatx'
time ./intRdatx < intRdatx.inp$1

if ("$?" == "0") then

cat dalhads.dat >> $name.f

if ( -r EClabel ) then
  set nf = `cat EClabel`
  if ("$nf" == "") then
    echo ' results in '$name'.f'
  else	 
     set file = $name'_'$nf'.f'
     mv $name.f $file
  endif
else
endif
	
endif

exit

exit 0
usage:
echo "Usage intRdatx option channel=0,2,4"
echo " 0 input set from intRdatx.inp"
echo " 1 = hadr5n time-like low der"
echo " 2 = hadr5n space-like der"
echo " 3 = hadr5n time-like high der"
echo " 4 = hadr5n time-like low deg"
echo " 5 = hadr5n space-like deg"
echo " 6 = hadr5n time-like high deg"
echo " 7 = hadr5n time-like low deg3"
echo " 8 = hadr5n space-like deg3"
echo " 9 = hadr5n time-like high deg3"
echo "10 = amuhad(K3c) 1st integral scan"
echo "11 = hadr5n space-like high der"
echo "12 = hadr5n space-like high deg"
echo "13 = hadr5n space-like high de3"
echo "14 = amuhad(K3c) 2nd integral"
echo "15 = amuhad(K3c) 2nd integral error"
exit 2
