       SUBROUTINE RENORMALIZE2(energy,reno,reno2)
       IMPLICITREAL*8(A-Z)
C flag for which leptons have been subtracted as VP corrections in data
C reno1 is old 2003 version; reno2 yields correction old to new VP subtraction
       CHARACTER*3 LEPTONflag1
       INTEGER i,IKE,IPV,IREN,IRENO,ILEPTONS,IGEV
       REAL*8 ML1(3),EGeV
***************** part to be included also in main program **************
       include 'common.h'
       common /parm/st2,als,mtop
       common /resu/dalept,dahadr,daltop
       COMMON/FFF/IKE,IPV,IREN,IRENO
C Parameters for this routine: LEPTONflag1 only switches between ele and lem=ele+muo
       COMMON/BHAB/ME2,COSTHETA,LEPTONflag1
       COMMON/lema/ml1,IGEV
       call constants()
       me=ml(1)
       me2=me*me
c      sin2ell=0.23153 ! pm 0.00016 LEPEEWG Phys Rep 427 (2006) 257
       st2=0.23153d0            ! Reference value for weak mixing parameter
       als=0.1184d0       ! alpha strong
       mtop=172.9D0       ! top quark mass
C LEPTONflag=all,had,lep,ele,muo,tau,lem -> iLEP=-3,-2,-1,1,2,3,4
C Some VP subtractuions only include the electron = ele or electron plus muon = lem
C Default:
C      LEPTONflag='all'
C      iLEP  = -3  ! for sum of leptons + quarks
C Decomment in main the following 2 lines for changing the default
c      LEPTONflag='all'   ! choose had,lep,top,ele,muo,tau,lem
c      iLEP=LFLAG(LEPTONflag)
************************************************************************
c# Summary: IRENO (what to calculate) =0 raw data ,
c#                                    -1 undressed,
c#                                     1 physical dressed,
c#          IREN (type of data)       =0 undressed data (full VP subtracted)
c#                                     1 partially corrected (e VP only),
c#                                     2 physical (e.g., PDG widths),
c#                                     3 undressed pQCD (perturbative tail)
c#                                     4 do not renormalize; set reno=1
c# Renormalization factors:
c#     r1= undo electron loop (1+2dalp(ele)(s))/(1+2dalp(ele)(t))
c#     r2= undress [alpha(0)/alpha(s)]^2=(1-dalp(s))^2
c#     r3= normalizing by Bhabha [alpha(t)/alpha(0)]^2=1/(1-dalp(t))^2
c#  (IRENO,IREN)= ( 0,0) :   reno= 1
c#                ( 0,1) :         1
c#                ( 0,2) :         1
c#                ( 0,3) :         1
c#                ( 0,4) :         1
c#                ( 1,0) :         1/r2
c#                ( 1,1) :         r1*r3
c#                ( 1,2) :         1
c#                ( 1,3) :         1/r2
c#                ( 1,4) :         1
c#                (-1,0) :         1
c#                (-1,1) :         r1*r2*r3
c#                (-1,2) :         r2
c#                (-1,3) :         1
c#                (-1,4) :         1
       null=0.d0
       reno=1.d0
       E=energy
c       IF ((IREN.NE.3).AND.(abs(E).GT.1.D2)) E=E*1.D-3
       EGeV=E
       IF (IGEV.EQ.0) EGeV=E*1.D-3
       if (E.LT.null) then
          reno2=1.d0
       else
          CALL renotab2(EGeV,renooldnew,0)
          reno2=renooldnew
       endif
       s=EGeV*EGeV
       IF ((IRENO.EQ.0).OR.(IREN.EQ.4)) THEN
         reno=1.d0
         return
       ENDIF
       t=(s-4.d0*ME2)*(COSTHETA-1.d0)/2.d0
       Q=-sqrt(-t)
       if (E.LT.0.d0) s=-abs(s)
C assume for large E we may apply space-like s
       if (E.GT.3.D0) s=-abs(s)
       alps=funalpqedrx(s,error,errorsta,errorsys,'all')
       dals=dalept+dahadr+daltop
       alpt=funalpqedrx(t,error,errorsta,errorsys,'all')
       dalt=dalept+dahadr+daltop
       if (LEPTONflag1.EQ.'ISR') then
          r1=1.d0
       else
          dalms=0.d0
          dalmt=0.d0
          dales=0.d0
          dalet=0.d0
C electron + muon only : LEPTONflag='lem'
          if (LEPTONflag1.EQ.'lem') then
             ales=funalpqedrx(s,error,errorsta,errorsys,'muo')
             dalms=dalept
             alet=funalpqedrx(t,error,errorsta,errorsys,'muo')
             dalmt=dalept
          endif
C electron only : LEPTONflag='ele'
          if ((LEPTONflag1.EQ.'lem').or.(LEPTONflag1.EQ.'ele')) then
             ales=funalpqedrx(s,error,errorsta,errorsys,'ele')
             dales=dalept
             alet=funalpqedrx(t,error,errorsta,errorsys,'ele')
             dalet=dalept
          endif
C add muon if to be included
          dales=dales+dalms
          dalet=dalet+dalmt
          r1=(1.d0+2.d0*dales)/(1.d0+2.d0*dalet)  ! undo e or e + mu loop subtraction
       endif
       r2=(1.d0-dals)**2                          ! undressing factor
       r3=1.d0/(1.d0-dalt)**2                     ! Bhabha correction factor
       if (COSTHETA.EQ.0.D0) r3=1.d0/r2             ! mumu for normalization
       IF (IRENO.EQ.1) THEN
         IF ((IREN.EQ.3).OR.(IREN.EQ.0)) THEN
C dressing perturbative tail or
C vapo was subtracted in data; calculate dressed cross-section
           reno=1.d0/r2
         ELSE IF (IREN.EQ.1) THEN
C partial vapo subtraction assuming that only electron contribution has
C been subtracted (Martin-Bonneau, Kuraev-Fadin, Jackson-Scharre,.. approx.)
           reno=r1*r3
         ELSE IF (IREN.EQ.2) THEN
C full vapo subtraction mainly for resonances parametrized in terms of
C "dressed" widths
           reno=1.d0
         ENDIF
       ELSE IF (IRENO.EQ.-1) THEN
         IF (IREN.EQ.1) THEN
C partial vapo subtraction assuming that only electron contribution has
C been subtracted (Martin-Bonneau, Kuraev-Fadin, Jackson-Scharre,.. approx.)
           reno=r1*r2*r3
         ELSE IF (IREN.EQ.2) THEN
C full vapo subtraction mainly for resonances parametrized in terms of
C "dressed" widths
           reno=r2
         ELSE IF ((IREN.EQ.0).OR.(IREN.EQ.3))  THEN
           reno=1.d0
         ENDIF
       ENDIF
       RETURN
       END
