C-{{{ subroutine alphas(scms)

      subroutine alphas(mux,alsx,ior,nfx)
c..
c..   Prepare everything for the actual calculation.
c..
c..   scms = center-of-mass energy squared
c..
      implicit	real*8(a-h,m-z)
      implicit	integer(i,j)
      implicit	character*60(k)
      implicit  logical(l)
      integer ior,nfx
      common /iecheck/iecheck

      include 'common.f'

c..   load non-user parameters:
      scms=mux**2
      mu=mux
      iord=ior
      call fixpar(scms)

c..   run some checks on the input:
      call checkin(scms,lpass)
      if (.not.lpass) stop

      lcharm = .false.
      lbottom = .false.
      ltop = .false.
      if (scms.ge.thrc**2 * xltbuf) then
         lcharm = .true.
         if (scms.ge.thrb**2 * xltbuf) then
            lbottom = .true.
            if (scms.ge.thrt**2 * xltbuf) then
               ltop = .true.
            endif
         endif
      endif

c..   determine inffin from scms and thr{c,b,t}
      inffin = 3
      if(ltop)then
         inffin = 6
      elseif(lbottom)then
         inffin = 5
      elseif(lcharm)then
         inffin = 4
      endif
c..   compute alpha_s(mu)
      call rundecalpha(alphasmz,mz,mu,als)
      api = als/pi
      alsx=als
      nfx=inffin
c      write (*,*) ' -2- rhad/alphas.f nfx',nfx
      if (lmsbar) then         
c..   compute mq(mu) from mq(mq):
         if (lcharm) then
            call rundecmass(massc,4,massc,mu,mc)
         else
            call mms2mos(massc,4,iord,mc)
         endif
         if (lbottom) then
            call rundecmass(massb,5,massb,mu,mb)
         else
            call mms2mos(massb,5,iord,mb)
         endif
         if (ltop) then  
            call rundecmass(masst,6,masst,mu,mt)
         else
            call mms2mos(masst,6,iord,mt)
         endif
      else
c..   input: pole quark masses
         mc = massc
         mb = massb
         mt = masst
      endif

c..   fix some inconsistencies:
      if (la3m4) la3m2 = .true.  !  no m^4-terms without m^2-terms
      if (lmassless) then
         la3m2 = .false.
         la3m4 = .false.
         la4m2 = .false.
      endif

c..   print parameters:
      if ( lverbose ) call printpar(scms)

c..   check if energy region makes sense
      iecheck=0
      if (((scms.gt.thrclow**2 * xgtbuf).and.
     &     (.not.lcharm)).or.
     &     ((scms.gt.thrblow**2 * xgtbuf).and.
     &     (.not.lbottom)).or.
     &     ((scms.gt.thrtlow**2 * xgtbuf).and.
     &     (.not.ltop))) then
         if (iwarn.eq.1) then
            write(6,2003) dsqrt(scms)
         endif
 2003 format(
     &     'WARNING: sqrt(s)=',1f8.3,' GeV not in region where ',/
     &     '         perturbation theory can be applied.'
     &     )
      if (iwarn.eq.1) then
         iecheck=1
      endif
      endif
      return
      end

C-}}}
