      subroutine rqcdHS(s,R,ALINP,EINP,MTOP,IOR,NFext)
Calculation of R-value to 4-loop
c..
c..   ***********
c..   "rhad: a program for the evaluation of the hadronic
c..      R-ratio in the perturbative regime of QCD"
c..
c..   by Robert V. Harlander and Matthias Steinhauser
c..   ***********
c..
c..   To compile, copy this file to the source directory of rhad, and say
c..
c..   gmake prog=rqcdHS
c..   The object will be named rqcdHS.o
c..
c this interface overwrites the parameters specified in the rqcdHS parameterlist
c which otherwise are provided via parameters.f
      implicit real*8(a-h,m-z)
      implicit integer(i,j)
      implicit character*60(k)
      implicit logical(l)
      integer IOR,NFext,nf
      real *8 s,R,ALINP,EINP,MTOP
      real *8 mq(6),mp(6),th(6)
      real *8 muinp,mp4inp,mp5inp
      common /iecheck/iecheck

      include 'common.f'

c eventually provide quark masse and thresholds here mq msbar, mp pole, th flavor thresold
      common /quama/mq,mp,th

c for error handing in renormalization scale, c_mass and b_mass change at runtime
c uncomment relevant lines in this file
      common /rhadparts/ru,rd,rs,rc,rb,rt,rsg,rem
      common /input/muinp,mp4inp,mp5inp
      data ifirst /0/

      sqrts = sqrt(s)
      scms  = sqrts*sqrts

      call parameters(scms)
c
cSettings in parameters
c
c      alphasmz  = 0.118d0

      alphasmz  = ALINP

c.. order in pQCD
c      iord  = 4 ! default

      iord=IOR


c..   use MS-bar or pole quark mass?  (.true. == MS-bar mass)
c      lmsbar    = .false.

      lmsbar    = .false.

c.. msbar renormalization scale

c      mu=muinp

c..   masses
      massc      = 1.65d0        ! charm
      massb      = 4.75d0        ! bottom
      masst      = 174.2d0        ! top
c..   masses

      massc      = mp(4)       ! charm
      massb      = mp(5)       ! bottom
      masst      = MTOP        ! top

c      massc      = mp4inp       ! charm
c      massb      = mp5inp       ! bottom
c      masst      = MTOP         ! top

c..   renormalization scale:
      mu        = dsqrt(scms)

c..   decoupling scales:
c      muc       = 2.d0*massc    ! charm
c      mub       = massb         ! bottom
c      mut       = masst         ! top

c..   threshold for open quark production
c      thrc = 4.8d0
c      thrb = 11.2d0
c      thrt = 2*masst+10.d0

      thrc = th(4)
      thrb = th(5)
      thrt = th(6)
c      write (*,*) ' INPUT:',muinp,mp4inp,mp5inp
c..   lower bound of quark threshold region
c      thrclow = 3.73d0
c      thrblow = 10.52d0
c      thrtlow = 2*masst-10.d0

c..   minimum allowed cms energy:
c      sqmin     = 1.8d0

      call init(scms)
      if (ifirst.eq.0) then
         call printpar(scms)
         ifirst=1
      endif

      rall = rhad(scms)
      ru = ruqrk(scms)
      rd = rdqrk(scms)
      rs = rsqrk(scms)
      rc = rcqrk(scms)
      rb = rbqrk(scms)
      rt = rtqrk(scms)
      rsg = rsinglet(scms)
      rem = rqed(scms)
      if (rs.eq.0.d0) then
         write (*,*) ' less than 3 flavors: pQCD fails! '
      else if (rc.eq.0.d0) then
         nf=3
      else if (rb.eq.0.d0) then
         nf=4
      else if (rt.eq.0.d0) then
         nf=5
      else
         nf=6
      endif
      if (iecheck.eq.1) write (*,*) sqrts,rall
      if (NFext.eq.6) R=rall
      if (NFext.eq.5) R=rall-rt
      if (NFext.eq.4) R=rall-rt-rb
      if (NFext.eq.3) R=rall-rt-rb-rc
      return
      end
