C#	$Id: rqcd3m.f,v 1.3 1996/05/19 00:17:41 fjeger Exp fjeger $	
C;;;;;;;;;;;;;;;;;;;;;;;;;;;;; -*- Mode: Fortran -*- ;;;;;;;;;;;;;;;;;;;;;;;;;;
C;; rqcd3m.f -- 
C;; Copyright (C) F. Jegerlehner 1998. Email: <fjeger@ifh.de>
C;; 
C;; Author          : Fred Jegerlehner
C;; Created On      : Thu May 21 13:39:30 1998
C;; Last Modified By: Friedrich Jegerlehner
C;; Last Modified On: Tue Sep  1 15:07:39 2009
C;; Update Count    : 1
C;; Status          : Unknown, Use with caution!
C;; 
C;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
C
      subroutine rqcd3m(s,R,ALINP,EINP,MTOP,FTQ,IOR,NF)
Calculation of R-value to 3-loop
C link QCDPAR1 to get running parameters
C improved mass correction a la Chetyrkin&K\"uhn
      implicit none
      integer  NFX,FTQ,IOR,ini,NF,i_2,i_3,i_4,i_5,initx1,initx2
      real *8 s,R,ALINP,EINP,MTOP,AL,E,dlog
      real *8 pi,adp,r1,r2,Qrat,R0,R04,R05,betac,betab,betat,sx
      real *8 adp2,adp3,epadp0,epadp,epadpc,cx,xc,zeta2,mc2,mb2
      real *8 sdmb2,mc2ds,mc2ds2,lmc2ds,RNS,DRmb,RS,DRmc,mb2ds,mb2ds2
     .       ,mb2ds3,lmb2ds,DRm,mcpol,mbpol
      REAL *8 MQ(6),MP(6),TH(6)
      data pi /3.141592653589793d0/
      COMMON /QUARK/MQ,MP,TH
      data ini/0/initx1/0/initx2/0/

       call rqcdparam()   ! fill make sure QUARK has standard values

      zeta2=pi**2/6.d0
      R04  =10.d0/3.d0
      R05  =11.d0/3.d0
      TH(5)= 9.46D0
      E=dsqrt(s)
      sx=s
      if (E.LT.TH(3)) then
         R=5.d0/3.d0
         if (initx1.eq.0) then
c            write (*,*) ' R_QCD=5/3 for E < 1 GeV used! '
            initx1=1
         endif
         return
      elseif (E.LE.TH(4)) then
         R=2.d0   ! lowest order estimate
         if (initx2.eq.0) then
c            write (*,*) ' R_QCD= 2  for 1 < E <= 3.1 GeV used! '
            initx2=1
         endif
         return
      endif
      if (IOR.GT.0) then
        call ALQCD2(sx,ALINP,EINP,MTOP,AL,nfx,FTQ,IOR)
      endif
      adp=al/pi
      adp2=adp**2
      adp3=adp2*adp
      epadp0=1.d0+adp
      cx =4.d0*pi*al/3.d0
      mc2=mq(4)**2
      mb2=mq(5)**2
      if (E.LE.TH(5)) then
         Qrat=2.d0/9.d0
C c quark threshold factor
         mc2=mq(4)**2
         betac=0.d0
         epadpc=1.d0
         if (E.GT.2.d0*mq(4)) then
           betac=dsqrt(1.d0-4.d0*mc2/s)
           xc  =cx/betac
           epadp=xc/(1.d0-dexp(-xc))-(3.d0+betac)*(zeta2-0.25d0)*adp
           epadpc=epadp/epadp0
         endif
         R0  =2.d0+4.d0/3.d0*betac*(3.d0-betac**2)/2.d0
C      elseif (E.LE.2.D0*MTOP) then
      else
         Qrat=1.d0/33.d0
C b quark threshold factor
         mb2=mq(5)**2
         betab=0.d0
         epadpc=1.d0
         if (E.GT.2.d0*mq(5)) then
           betab=dsqrt(1.d0-4.d0*mb2/s)
           xc  =cx/betab
           epadp=xc/(1.d0-dexp(-xc))-(3.d0+betab)*(zeta2-0.25d0)*adp
           epadpc=epadp/epadp0
         endif
         R0  =R04+1.d0/3.d0*betab*(3.d0-betab**2)/2.d0
C      else
C         Qrat=3.d0/15.d0
CC t quark threshold factor
C         betat=0.d0
C         if (E.GT.2.D0*MTOP) betat=dsqrt(1.d0-4.d0*MTOP**2/s)
C         R0  =R05+4.d0/3.d0*betat*(3.d0-betat**2)/2.d0
      endif
      if ((NF.EQ.6).and.(E.GT.2.D0*MTOP) ) then
         Qrat=3.d0/15.d0
C t quark threshold factor
         betat=0.d0
         epadpc=1.d0
         if (E.GT.2.D0*MTOP) then
           betat=dsqrt(1.d0-4.d0*MTOP**2/s)
           xc  =cx/betat
           epadp=xc/(1.d0-dexp(-xc))-(3.d0+betat)*(zeta2-0.25d0)*adp
           epadpc=epadp/epadp0
         endif
         R0  =R05+4.d0/3.d0*betat*(3.d0-betat**2)/2.d0
      endif
      r1= 1.9857d0-0.1153d0*nfx
      r2=-6.6368d0-1.2002d0*nfx-0.0052d0*nfx**2-1.2395d0*Qrat
      if ((nfx.eq.5).and.(ini.eq.0)) then
        write (*,*) ' nf,c1:',nfx,adp
        write (*,*) '    c2:',r1*adp2
        write (*,*) '    c3:',r2*adp3
C        ini=1
      endif
C get quark mass at 1GeV as an input for QCDPAR1 if other than
C Gasser&Leutwyler values should be used: input pole-mass mq=mq(mq)
C used in Chetyrkin&K\"uhn
      if (ini.eq.0) then
        mcpol=1.11d0
        mbpol=4.70d0
        if (IOR.GT.0) then
          call SETQM1(mcpol,ALINP,EINP,MTOP,4,2,3)
          call SETQM1(mbpol,ALINP,EINP,MTOP,5,2,3)
        endif
        ini=1
      endif
      if (IOR.eq.0) then
        R=R0
      else if (IOR.eq.1) then
        R=R0*(epadp0)
      else if (IOR.eq.2) then
        R=R0*(epadp0+r1*adp2)
      else
        R=R0*(epadp0+r1*adp2+r2*adp3)
C
C Chetyrkin&K\"uhn PRL B342 (1995) 356
C
      if ((e.gt.4.5d0).and.(e.le.11.5d0)) then
        TH(5)=11.5D0
        if (IOR.GT.0) then
          call ALQCD2(sx,ALINP,EINP,MTOP,AL,nfx,2,3)
          call M2QCD2(sx,ALINP,EINP,MTOP,mc2,4,2,3)
          call M2QCD2(sx,ALINP,EINP,MTOP,mb2,5,2,3)
        endif
        sdmb2 =s/mb2
        mc2ds =mc2/s
        mc2ds2=mc2ds**2
        lmc2ds=dlog(mc2ds)
        RNS =R04*(1.d0+adp+1.5245d0*adp2-11.52033d0*adp3)
        RS  =-0.55091*adp3
        DRmb=R04*adp2*sdmb2*(44.d0/675.d0-2.d0/135.d0*dlog(sdmb2))
        DRmc=16.d0*adp*mc2ds*(1.d0+9.097d0*adp+53.453d0*adp2)
     .      -R04*mc2ds*adp3*6.476d0
     .      -4.d0/3.d0*mc2ds2*(6.d0+22.d0*adp
     .      -(141.329d0-25.d0/6.d0*lmc2ds)*adp2)
     .      -R04*mc2ds2*adp2*(0.4749d0+lmc2ds)
        R=RNS+RS+DRmb+DRmc
C      write (*,*) ' '
C      write (*,*) r0,rns,rs
C      write (*,*) r,drmb,drmc
      endif
        if ((e.gt.11.5d0).and.(e.lt.40.d0)) then
          TH(5)=11.5D0
          if (IOR.GT.0) then
            call ALQCD2(sx,ALINP,EINP,MTOP,AL,nfx,2,3)
            call M2QCD2(sx,ALINP,EINP,MTOP,mc2,4,2,3)
            call M2QCD2(sx,ALINP,EINP,MTOP,mb2,5,2,3)
          endif
          mb2ds =mb2/s
          mb2ds2=mb2ds**2
          mb2ds3=mb2ds2*mb2ds
          lmb2ds=dlog(mb2ds)
          mc2ds =mc2/s
          mc2ds2=mc2ds**2
          lmc2ds=dlog(mc2ds)
          RNS =R05*(1.d0+adp+1.5245d0*adp2-11.52033d0*adp3)
          RS  =-0.55091*adp3
          DRm =(4.d0*mc2ds+mb2ds)*4.d0
     .        *(1.d0+8.736d0*adp+45.657d0*adp2)*adp
     .        -R05*(mc2ds+mb2ds)*adp3*6.126d0
     .        -4.d0/3.d0*mc2ds2*(6.d0+22.d0*adp
     .        -(139.488d0-23.d0/6.d0*lmc2ds+12.d0*mb2/mc2)*adp2)
     .        -1.d0/3.d0*mb2ds2*(6.d0+22.d0*adp
     .        -(139.488d0-23.d0/6.d0*lmb2ds+12.d0*mc2/mb2)*adp2)
     .        -R05*mc2ds2*adp2*(0.4749d0+lmc2ds)
     .        -R05*mb2ds2*adp2*(0.4749d0+lmb2ds)
     .        -1.d0/3.d0*mb2ds3*(8.d0
     .        +16.d0/27.d0*adp*(6.d0*lmb2ds-155.d0))
          R=RNS+RS+DRm
c      write (2,*) ' '
c      write (2,*) ' rqcd3m ',sqrt(mb2ds)
c      write (2,*) r0,rns,rs
c      write (2,*) r,drm
        endif
      endif
      return
      end
