      function RS(S)
      implicit none
      integer i,FTQ,IOR,IOR1,NF,ICHK
      integer loops, nf1, R2, R4
      real *8 S,R,RS,ALINP,EINP,MTOP,pi
      real *8 mq(6),mp(6),th(6)
      real*8 ARUN, alpha0, mu0, mu1, Mth(6), muth(6)
      real*8 Rpt, sqrts, alpha, rv
      common /inp/pi,ALINP,EINP,MTOP
      common /int/FTQ,IOR,NF,ICHK
      common /quama/mq,mp,th
c
      if (ICHK.EQ.0) then
         call rqcd3(S,R,ALINP,EINP,MTOP,FTQ,IOR,NF) 
      else if (ICHK.EQ.1) then
         call rqcd3m(s,R,ALINP,EINP,MTOP,FTQ,IOR,NF)
      else if (ICHK.EQ.2) then
        call rqcd3mn(s,R,ALINP,EINP,MTOP,FTQ,IOR,NF)
      else
c  Given: 
c       alpha0(mu0) --- initial value at reference point
c       mu0         --- reference point
c       Mth(1:6)    --- array of thresholds (in On-Shell scheme) 
c       muth(1:6)   --- array of decoupling scales
c       mu1         --- new point
c       loops       --- number of loops (1,2,3,4) 
c       
         do i=1,6 
           Mth(i)  = mp(i)
           muth(i) = th(i)
         enddo
         sqrts=sqrt(s)
         alpha0=alinp
         mu0   =einp
         loops =ior
         mu1   =sqrts
         alpha = ARUN ( alpha0, mu0, Mth, muth, mu1, loops, nf1 )

c  Arguments:
c     sqrts = sqrt(s)  (in GeV)
c             must be > 10.0 GeV
c     alpha = alpha(s)
c             note that mu=s in the following
c             therefore alpha should be taken as alpha(s)
c     loops = 1,...,4
c             1 correspond to parton model (no QCD corr.)
c             4 QCD corr. to O(alpha^3)
c
c      R2, R4 = 0 or 1
c        we have further two parameter R2 and R4 to 
c        swich on/off mm and mm^2 corections correspondingly.
        r2=1
        r4=1
        R =Rpt( sqrts, alpha, loops, R2, R4 )
      endif
      RS=R
      return
      end
