#!/bin/csh -fx
if ("$1" == "") then
set emin = 0.689
else
set emin= ($1)
endif
if ("$2" == "") then
set emax = 1.06
else
set emax= ($2)
endif
if ("$3" == "") then
set iresonances = 1
else
set iresonances = $3
endif
if ("$4" == "") then
set IRESON = 1
else
set IRESON = $4
endif

echo $emin, $emax > Rin.inp 
echo $iresonances, $IRESON >> Rin.inp

make -f Makefile_Rdat prog=test_RSN2

echo ' run  test_RSN2'
time ./test_RSN2 < ./Rin.inp 

cat fort.1 > testRSN2_1.dat
cat fort.2 > testRSN2_2.dat
cat fort.3 > testRSN2_3.dat

make -f Makefile_Rdat prog=test_R3Gdat

echo ' run  test_R3Gdat'
time ./test_R3Gdat < ./Rin.inp


cat fort.1 > testRS3G_1.dat
cat fort.2 > testRS3G_2.dat
cat fort.3 > testRS3G_3.dat


make -f Makefile_Rdat prog=test_R33dat

echo ' run  test_R33dat'
time ./test_R33dat < ./Rin.inp


cat fort.1 > testRS33_1.dat
cat fort.2 > testRS33_2.dat
cat fort.3 > testRS33_3.dat

make -f Makefile_Rdat prog=test_RGGdat

echo ' run  test_RGGdat'
time ./test_RGGdat < Rin.inp


cat fort.1 > testRSGG_1.dat
cat fort.2 > testRSGG_2.dat
cat fort.3 > testRSGG_3.dat

make -f Makefile_Rdat

echo ' run  test_Rdat'
time ./test_Rdat < ./Rin_renopt.inp


cat fort.1 > testRdat_1.dat
cat fort.2 > testRdat_2.dat
cat fort.3 > testRdat_3.dat

echo "Results in testSSN2_i.dat testRS3G_i.dat testRS33_i.dat testRdat_i.dat i=1,2,3"

cat test_RSXY.par > testRXYplot.par
echo "C 01=RSN2 data, 02=Fits, 05=pQCD" 
echo "U    03R#IL#N2#CL#(s)\
L 07 01 02 03 04 05 06 07\
X    05   1.00000 Vorgabe v. Extremwerten:0.(n),1.(xmax,xmin),2.(xmax),3.(xmin)\
X    06   $emin\
X    07   $emax\
Y    05   0.00000 Vorgabe v. Extremwerten:0.(n),1.(ymax,ymin),2.(ymax),3.(ymin)\
Y    06   0.0000  ymin\
Y    07   5.0000 ymax" >> testRXYplot.par

$HOME/andromeda/gra/fjplo3 testRXYplot

cat test_RSXY.par > testRXYplot.par
echo "C 08=RS3G data, 09=Fits, 12=pQCD"
echo "U    03R#IL#3G#CL#(s)\
L 07 08 09 10 11 12 13 14\
X    05   1.00000 Vorgabe v. Extremwerten:0.(n),1.(xmax,xmin),2.(xmax),3.(xmin)\
X    06   $emin\
X    07   $emax\
Y    05   0.00000 Vorgabe v. Extremwerten:0.(n),1.(ymax,ymin),2.(ymax),3.(ymin)" >> testRXYplot.par

$HOME/andromeda/gra/fjplo3 testRXYplot

cat test_RSXY.par > testRXYplot.par
echo "C 15=RS33 data, 16=Fits, 19=pQCD"
echo "U    03R#IL#33#CL#(s)\
L 07 15 16 17 18 19 20 21\
X    05   1.00000 Vorgabe v. Extremwerten:0.(n),1.(xmax,xmin),2.(xmax),3.(xmin)\
X    06   $emin\
X    07   $emax\
Y    05   0.00000 Vorgabe v. Extremwerten:0.(n),1.(ymax,ymin),2.(ymax),3.(ymin)" >> testRXYplot.par

$HOME/andromeda/gra/fjplo3 testRXYplot

cat test_RSXY.par > testRXYplot.par
echo "C 29=Rdat data, 30=Fits, 33=pQCD"
echo "U    03R(s)\
L 07 29 30 31 32 33 34 35\
X    05   1.00000 Vorgabe v. Extremwerten:0.(n),1.(xmax,xmin),2.(xmax),3.(xmin)\
X    06   $emin\
X    07   $emax\
Y    05   0.00000 Vorgabe v. Extremwerten:0.(n),1.(ymax,ymin),2.(ymax),3.(ymin)\
Y    06   0.000  ymin\
Y    07  20.6000 ymax" >> testRXYplot.par

$HOME/andromeda/gra/fjplo3 testRXYplot

cat test_RSXY.par > testRXYplot.par
echo "C 22=Rdat data, 23=Fits, 26=pQCD"
echo "U    03R(s)\
L 07 22 23 24 25 26 27 28\
X    05   1.00000 Vorgabe v. Extremwerten:0.(n),1.(xmax,xmin),2.(xmax),3.(xmin)\
X    06   $emin\
X    07   $emax\
Y    05   0.00000 Vorgabe v. Extremwerten:0.(n),1.(ymax,ymin),2.(ymax),3.(ymin)\
Y    06   0.000  ymin\
Y    07  20.6000 ymax" >> testRXYplot.par

$HOME/andromeda/gra/fjplo3 testRXYplot


exit 0
usage:
test_Rdat.sh emin emax iresonances IRESON
exit 2

