      program testhadr5a
C calculates Delta alpha from 5 quark sector, using tabled in hadr5n17.f 

      implicit none
      integer i,j,N,stflag,logflag,Ismooth,Nall,ndat,N1,N2,ifullrange,
     &     iOSW
      parameter(Nall=2187)
      REAL *8 X(Nall)
      INTEGER NA,NB
      PARAMETER(NA=979,NB=200)
      REAL ETX(NA),ESX(NB),XXX(NB)
      double precision e,s,st2,der,errder,errdersta,errdersys,
     &     deg,errdeg,errdegsta,errdegsys,de,emax,emin
      real*8 elogl,elogu,delog,elog,fep,fem,fractionalerror
********************* extended header for real, complex as well as resonance data access **************
      REAL*8 MRO,MOM,MFI,GRO,GOM,GFI,PRO,POM,PFI
      REAL*8 PSI(6),MPS(6),GPS(6),PPS(6),YPI(6),MYP(6),GYP(6),PYP(6)
      REAL*8 STAPS(6),SYSPS(6),STAYP(6),SYSYP(6)
      REAL*8 RMA(15),RGA(15),RPA(15),EREM(15),EREG(15),EREP(15),
     &     EMI(15),EMA(15)
      integer nx,ny
      parameter(nx=400,ny=15)
      integer nres(ny),ini_reso_reno_dat
      double precision renpts(nx,ny),renofa(nx,ny),fracerr(nx,ny)
      include 'common.h'      
c parameters resonances
      COMMON/BWRO/MRO,GRO,PRO/BWOM/MOM,GOM,POM/BWFI/MFI,GFI,PFI
      COMMON/PSYPPAR/MPS,GPS,PPS,MYP,GYP,PYP,STAPS,SYSPS,STAYP,SYSYP
      COMMON/RESALL/RMA,RGA,RPA,EREM,EREG,EREP
      COMMON/RESRAN/EMI,EMA
      common/renormBW/renpts,renofa,fracerr,nres,ini_reso_reno_dat
      call constants()
      call constants_qcd() ! fills commons var and RCUTS
      call resonances_data() ! fills commons resonance parameters
c      sin2ell=0.23153 ! pm 0.00016 LEPEEWG Phys Rep 427 (2006) 257
      st2=0.23153d0   ! Reference value for weak mixing parameter
      ifullrange=1
c      ndat=1 low energy time-like data points extended by resonance scans
c      ndat=2 pQCD tail
c      ndat=3 test resonances at peak
c      ndat=-1 space-like region
      ndat=1
      ndat=0
c      ndat=3
c
      include 'xRdat-extended.f' ! just DATA X/.../ statement
      include 'xRdat-spacelikehigh.f' ! just DATA XXX/.../ statement
c      
c caution: logatithmic scaling used below: cannot choose emin=0 or emax=0 !!!!
c      
      logflag=0
      stflag =1
c     for spacelike region: stflag=-1
c      stflag =-1
c threshold 0.27914036d0
      emin=1.d-6
      emin=.27d0
      emax=11.5d0
      emin=-5.d0
      emax= 5.d0
c      emax=91.19d0
c J/psi,psi's
c      emin=3.09660 ! xmin psi1
c      emax=3.09720 ! xmax psi1
c      emin=3.68500 ! xmin psi2
c      emax=3.68700 ! xmax psi2
c      emin=3.72000 ! xmin psi3
c      emax=3.84000 ! xmax psi3
c      emin=3.96000 ! xmin psi4
c      emax=4.10000 ! xmax psi4
c Upsilon's
c 9460.30D
c      emin= 9.4600            ! xmin ups1
c      emax= 9.4606            ! xmax ups1
c      emin=10.023200 ! xmin ups2
c      emax=10.023320 ! xmax ups2
c      emin=10.354600 ! xmin ups3
c      emax=10.355800 ! xmax ups3
      write (*,*) ' Prepared scans with energy point raster ',
     &     'xRdat-extended'
      write (*,*) ' ndat=1 low energy time-like data points ',
     &     'extended by resonance scans'
      write (*,*) ' ndat=2 pQCD tail'
      write (*,*) ' ndat=3 test resonances at peak'
      write (*,*) ' ndat=-1 space-like region'
      write (*,*) ' ndat=-2 space-like region high'
      write (*,*) ' ndat=0 prompt for individual range'
      write (*,*) ' Enter ndat:'
      read  (*,*) ndat
      if (ndat.eq.0) then
      write (*,*) ' Enter energy range and number of points: ',
     &     'emin,emax,N' 
      read (*,*) emin,emax,N
      endif
      if (ndat.eq.1) then
      write (*,*) ' Enter energy range: ',
     &     'emin,emax' 
      read (*,*) emin,emax
      endif
      if (ndat.eq.0) then
         write (*,*) ' stflag=1/-1/-2 [time/space-like/',
     &        'space-like reverted] ',
     &        'logflag=0/1 [linear/log scale]'
         write (*,*) ' Enter stflag,logflag:'
         read (*,*) stflag,logflag
      endif
      if (ndat.eq.0) then
         N1=1
         N2=N+1
      else if (ndat.eq.1) then
         call getindex(emin,Nall,X,N1)
         call getindex(emax,Nall,X,N2)
         if (ifullrange.eq.1) then
            N1=1
c            N2=Nall+1
            N2=Nall
         endif
      else 
c      if (ndat.eq. 1).and N=Nall-1
         if (ndat.eq. 2) N=NB-1
         if (ndat.eq.-1) N=NA-1
         if (ndat.eq.-2) N=NB-1
c      if (ndat.eq. 3) N=45-1
         if (ndat.eq. 3) N=15-1
         N1=1
         N2=N+1
      endif
c write header for graphx plot program
      do j=1,2
         write (j,*) '      4.0000'
         write (j,*) '      1.0000'
         write (j,*) '   ',float(N2-N1)
         write (j,*) '     hadr5n data'
      enddo
      write (1,*) ' e,der,errder,errder'
      write (2,*) ' e,deg,errdeg,errdeg'

      if (ndat.eq.0) then
         de=(emax-emin)/(N-1)
         e=emin-de
      else 
         de=(emax-emin)/N
         e=emin
      endif
      elogl=dlog(dabs(emin))
      elogu=dlog(dabs(emax))
      delog=(elogu-elogl)/N
      if (ndat.eq.0) N2=N
      do 10 i=N1,N2
         if ((ndat.eq.1).and.(e.le.X(Nall))) then
            e=X(i)
            s=e*e
         else if ((ndat.eq.2).and.(e.le.ESX(NB))) then
            e=ESX(i)
            s=e*e
         else if (ndat.eq.3) then
            e=RMA(i)
            s=e*e
         else if ((ndat.eq.-1).and.(e.le.ETX(NA))) then
            e=ETX(i)
            s=-e*e
         else if ((ndat.eq.-2).and.(e.le.XXX(NB))) then
            e=XXX(i)
            s=-e*e
         else 
            if (logflag.eq.1) then
               if (stflag.eq.1) then
                  elog=elogl+delog*(i-1)
               else
                  elog=elogu-delog*(i-1)
               endif
               e=dexp(elog)
               s=e*e*stflag
               e=dsqrt(dabs(s))*stflag
            else
               e=e+de
               s=e*abs(e)
            endif
         endif
         if (stflag.eq.-2) s=-s
         call dhadr5x(e,st2,der,errdersta,errdersys,
     &        deg,errdegsta,errdegsys)
         errder=sqrt(errdersta**2+errdersys**2)
         errdeg=sqrt(errdegsta**2+errdegsys**2)
         write (1,98) e,der,errder,errder
         write (2,98) e,deg,errdeg,errdeg
 10   continue
      write (*,*) ' display fjplo3 testhadr5x'
 98   format(4(2x,1pe12.5))
      stop
      END
