C#	$Id: vapotail.f,v 1.6 1996/07/20 23:17:35 fjeger Exp fjeger $	
C;;;;;;;;;;;;;;;;;;;;;;;;;;;;; -*- Mode: Fortran -*- ;;;;;;;;;;;;;;;;;;;;;;;;;;
C;; vapotail.f -- 
C;; Copyright (C) F. Jegerlehner 1998. Email: <fjeger@ifh.de>
C;; 
C;; Author          : Fred Jegerlehner
C;; Created On      : Thu May 21 13:29:26 1998
C;; Last Modified By: Friedrich Jegerlehner
C;; Last Modified On: Sat Aug 19 10:37:11 2017
C;; Update Count    : 2
C;; Status          : Unknown, Use with caution!
C;; 
C;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
C
C 24/10/2006 add IKE=7 for electron higher order class a)
      subroutine vapotail(E,Emax,RESUL,ALINP,EINP,MTOP,FTQ,IOR,NF,ICHK)
Calculation of integral from E to Emax (>1.D3=infinity) of R-value to 3-loop
C NF=6 with TOP contribution, NF<=5 5flavors only 
C link RQCD3m,QCDPAR1 to get running parameters
C 08/04/2012 RSt extended by flavor splitting options
C ICHK=2 usual rhad from HS =3 same but NF dynamically adjusted, =4 RS3G, =5 RS33  
C 29/06/2013 changed ICHK,4,5 output R=R3G,R=R33 --> R=2*R3G,R=4*R33
C 27/09/2013 IKE=9 EC t^4*G_3(t) implemented Adler slope now IKE=10
      implicit none
      logical lwrite
      integer  FTQ,IOR,ITES,IKE,IPV,IREN,IRENO,FTQ1,IOR1,IER,IER1
      integer  NF1,NF,NF_SAV,ICHK,ICH1,IPV_SAV
      INTEGER  NIT,IIT,IT
      INTEGER  LW, LIW, INF, NPTS
      PARAMETER(NPTS=1)
      PARAMETER (LW=320000,LIW=LW/4)
      INTEGER  IFAIL,IW(LIW),KOUNT
      REAL *8 W(LW),MP2,M2,MBOT,MPOL,EPSREL,SMIN,SINT,DS,DNT,T,ST
     .       ,VAPX,VAPP,VAPM,POINTS(NPTS)
      REAL *8 SL,SU,FINT,TINT,RINT,MX2,RESULT,ABSERR,R1,E1,RT,ET,TL,TU
     .       ,EPSABS,S0T,ALINP1,EINP1,MTOP1,RESUL,ABSER,XINT
      REAL *8 EPS,SUB,REL,REU,A,B,REMINDER,REMERROR,ETAILCUT,EINFTY,NULL
      real *8 s,E,Emax,RSt,RSeinftyNF2,ALINP,EINP,MTOP,
     &     pi,S1,alerr,CHPTCUT,EC,ECUT
      common/var/pi,ALINP1,EINP1,MTOP1,FTQ1,IOR1,NF1,ICH1
      common/QUAER/alerr,IER1
      COMMON/PAX/S0T,KOUNT
      COMMON/MFPI/MP2,M2/FFF/IKE,IPV,IREN,IRENO
      common/pri/lwrite
      COMMON /ERR/IER
      COMMON/RCUTS/CHPTCUT,EC,ECUT
      COMMON /TAIL/ETAILCUT,EINFTY
      DATA ITES/0/
      data pi /3.141592653589793d0/
      external FINT,TINT,RINT,XINT
c      write (*,*) ' vapotail:',ICHK,E,EMAX,sqrt(M2)
      NULL=0.D0
      POINTS(1)=NULL
      IPV_SAV=IPV
      IER1=IER
      NF_SAV=NF
c      write (*,*) ' vapotail --- 42:IKE,IER',IKE,IER
c          write (*,*) ' E,Emax,ALINP,EINP,MTOP,FTQ,IOR,NF,ICHK'
c          write (*,*) E,Emax,ALINP,EINP,MTOP,FTQ,IOR,NF,ICHK
      ITES=0
      ALINP1=ALINP
      EINP1 =EINP
      MTOP1 =MTOP
      FTQ1  =FTQ
      IOR1  =IOR
      NF1   =NF
      ICH1  =ICHK
      S1=E**2
C 01/10/13 CHANGES FROM 25 TO 27 TO AVOID D01AJF failure because SU=M2X in NF=2 tail above 2 GeV
      NIT=27
      EPSREL=1.D-2
      KOUNT=0
      MBOT=5.D0
      SMIN=(2.D0*MBOT)**2
      SINT=DMAX1(SMIN,M2)*100.D0
      S0T=SINT
c      write (*,*) ' vapotail: E,S0T,IKE',E,S0T,IKE
c      write (*,*) ' vapotail: E,sqt(M2)',E,sqrt(M2)
      DS=(SINT-SMIN)/NIT
      IF (ITES.EQ.1) THEN
c     IF ((ITES.EQ.0).AND.(lwrite)) THEN
c     ITES=1
C     Test R(s) for 3.1-9.4 GeV
         WRITE(9,*) '   3.000 '
         WRITE(9,*) '   1.000 '
         WRITE(9,*) '  62.000 '
         WRITE(9,*) ' 3.1-9.4 GeV: N=64'
         DO IIT=1,64
            S=(3.1+0.1*(IIT-1))**2
            ALINP1=ALINP
            VAPX=RSt(S)    
            ALINP1=ALINP+alerr
            VAPP=RSt(S)
            ALINP1=ALINP-alerr
            VAPM=RSt(S)            
            WRITE(9,98) SQRT(S),VAPX,VAPP,VAPM
         ENDDO
C Test R(s) for 9.5-40. GeV
         WRITE(10,*) '   3.000 '
         WRITE(10,*) '   1.000 '
         WRITE(10,*) '  62.000 '
         WRITE(10,*) ' 9.5-40. GeV: N=62'
         DO IIT=1,62
            S=(9.5+0.5*(IIT-1))**2
            ALINP1=ALINP
            VAPX=RSt(S)    
            ALINP1=ALINP+alerr
            VAPP=RSt(S)
            ALINP1=ALINP-alerr
            VAPM=RSt(S)            
            WRITE(10,98) SQRT(S),VAPX,VAPP,VAPM
         ENDDO
         ALINP1=ALINP
         WRITE(11,*) ' Test tail (vapotail.f)'
         DO IIT=1,NIT+1
            S=SMIN+DS*(IIT-1)
            VAPX=RSt(S)
            WRITE(11,98) SQRT(S),VAPX
         ENDDO
         WRITE(11,*) ' ****'
         DNT=0.5D0/NIT
         DO IIT=1,NIT
            T=0.5D0+DNT*(IIT-1)
            ST=S0T*T/(1D0-T)
            VAPX=RSt(ST)
            WRITE(11,98) SQRT(ST),VAPX
         ENDDO
         WRITE(11,*) ' $$$$'
      ENDIF
c End of test section
      SMIN=S1       ! S1=E**2
      SINT=EMAX**2
      IF (M2.GT.NULL) MPOL=SQRT(M2)
c      check hierarchy of energy cuts
      IF ((E.GE.EMAX).OR.(EMAX.GT.EINFTY).OR.(ETAILCUT.GT.EINFTY)
     &     .OR.(MPOL.GT.EINFTY)) THEN
         write (*,*) ' Check hierarchy EMIN,EMAX,MPOL,ETAILCUT,EINFTY'
         write (*,98) E,EMAX,MPOL,ETAILCUT,EINFTY
      ENDIF
c Euclidean correlators
      RESUL=0.D0
      ABSER=0.D0
      REMINDER=0.D0
      REMERROR=0.D0
      IF ((IKE.EQ.8).OR.(IKE.EQ.9)) THEN
c         NF1=2
         EPSABS = 0.0D0
         EPSREL = 1.0D-03
         A = SQRT(S1/M2)
         KOUNT = 0
         IFAIL = -1
         IF (E.GE.ECUT) THEN
c         IF ((E.GE.ECUT).AND.(MPOL.GE.E)) THEN
c -------ECUT-------E-------MPLO--------------
            INF = 1  ! SINT=M2 integrate up to MPOL
*     
            CALL D01AMF(XINT,A,INF,EPSABS,EPSREL,RESULT,ABSERR,
     &           W,LW,IW,LIW,IFAIL)
*     
c estimate of the missing part from MPLO to infty
c            IF (E.LT.MPOL) THEN
cc make sure we have R(s) at einfty for NF=2
c               RSeinftyNF2=1.7027d0    ! value for einfty=1d5
c               if (NF.EQ.2) RSeinftyNF2=RSt(EINFTY**2)
c               IF (IKE.EQ.8) REMINDER=RSeinftyNF2*1.83939720585721D0
c               IF (IKE.EQ.9) REMINDER=RSeinftyNF2*5.88607105874308D0
c               REMERROR=REMINDER*0.005d0
c               RESULT=RESULT+REMINDER
c               ABSERR=ABSERR+REMERROR
c               write (*,*) ' vapotail -- R(large) in EC tail',
c     &              NF,NF1,RSt(EINFTY**2)
c            ENDIF
         ELSE 
            B = SQRT(SINT/M2)
*     
            CALL D01AJF(XINT,A,B,EPSABS,EPSREL,RESULT,ABSERR,
     &           W,LW,IW,LIW,IFAIL)
         ENDIF
         RESUL=RESULT
         ABSER=ABSERR            
         RETURN
      ENDIF  ! Euclidean correlator done
c End Euclidean correlators
c      NF1 =NF_SAV
c First calculate without mapping integral up EMAX but at most up to ETAILCUT
      IF (MPOL.GT.ETAILCUT/2.d0) ETAILCUT=MPOL*2.d0
      IF (EMAX.LE.ETAILCUT) THEN
         SINT=EMAX**2
      ELSE
         SINT=ETAILCUT**2
      ENDIF
c looking at true tail contributing to the Euclidean correlator
c      IF (((IKE.EQ.8).OR.(IKE.EQ.9)).AND.(E.GE.ECUT)) THEN
c         IF (E.LT.MPOL) THEN
c            SINT=M2
c         ENDIF
c      ENDIF  ! this case is already returned above obsolete here ???
c direct calculation without mapping via FACT(s) kernel for EMAX up to ETAILCUT
      S0T=SINT
      DS=(SINT-SMIN)/NIT
      MX2=M2
      R1=0D0
      E1=0D0
      RESUL=0.D0
      ABSER=0.D0
c      if (lwrite) WRITE(*,*) ' vapotail: calculating below tail'
      DO  IIT=1,NIT
         SL=SMIN+DS*(IIT-1)
         SU=SMIN+DS* IIT
c         WRITE(*,*) sqrt(SL),sqrt(SU),SQRT(MX2),FINT(SL),FINT(SU)
         IF (((SL.LE.MX2).AND.(SU.GE.MX2))
     &        .AND.((IKE.EQ.1).OR.(IKE.EQ.2))) THEN
            IPV=1
            CALL D01AQF(FINT,SL,SU,MX2,0D0,EPSREL,RESULT,ABSERR,W,LW,
     .           IW,LIW,IFAIL)
            IF (IFAIL.NE.0) WRITE (*,99996) 'vapotail FINT -- 1:', IFAIL
         ELSE 
            IPV=0
            CALL D01AJF(FINT,SL,SU,0D0,EPSREL,RESULT,ABSERR,W,LW,
     .           IW,LIW,IFAIL)
            IF (IFAIL.NE.0) WRITE (*,99996) 'vapotail FINT -- 1:', IFAIL
         ENDIF
         R1=R1+RESULT
         E1=E1+ABSERR
         if (lwrite) WRITE(23,99) IKE,RESULT,ABSERR,KOUNT
      ENDDO
      EPSABS=R1*EPSREL
      DNT=0.125D0
      RT=0D0
      ET=0D0
      IPV=0
c      REMINDER=0.D0
c      REMERROR=0.D0
c now include tail contrubution if EMAX > ETAILCUT here mapping the tail 
      IF (EMAX.GT.ETAILCUT) THEN
cc Euclidean correlator         
c         IF ((IKE.EQ.8).OR.(IKE.EQ.9)) THEN 
c            IF (SINT.EQ.M2) THEN ! SINT=M2 was set for case E>ECUT and E<MPOL
cc -------ECUT-------E-------MPLO--------------
cc estimate of the missing part from MPLO to infty
cc               IF (IKE.EQ.8) RESULT=RSt(EINFTY**2)*1.8393972d0
c               IF (IKE.EQ.8) RESULT=RSt(EINFTY**2)*1.39777426564396D-02
c               IF (IKE.EQ.9) RESULT=RSt(EINFTY**2)*4.47287765006068D-02
c               REMERROR=RESULT*0.005d0
c               REMINDER=RESULT
c            ELSE IF (M2.LT.S1) THEN
c               EPSABS = 0.0D0
c               EPSREL = 1.0D-03
c               A = SINT
c               B = M2
c               INF = 1
c               KOUNT = 0
c               IFAIL = -1
c               
c               CALL D01AMF(FINT,A,INF,EPSABS,EPSREL,RESULT,ABSERR,
c     &              W,LW,IW,LIW,IFAIL)
c            ELSE 
c            ENDIF
c            RT=RESULT+REMINDER
c            ET=ABSERR+REMERROR
cc End Euclidean correlator
c         ELSE 
c         if (lwrite) WRITE(*,*) ' vapotail: calculating tail'
            DO  IT=1,4
               TL=0.5D0+DNT*(IT-1)
               TU=TL+DNT
               CALL D01AJF(TINT,TL,TU,EPSABS,EPSREL,RESULT,ABSERR,W,LW,
     .              IW,LIW,IFAIL)
               IF (IFAIL.NE.0) WRITE (*,99996) 'vapotail TINT -- 2:',
     &              IFAIL
               RT=RT+RESULT
               ET=ET+ABSERR
               if (lwrite) WRITE(23,99) IKE,RESULT,ABSERR,KOUNT
            ENDDO
c         ENDIF
      ENDIF
      RESUL=R1+RT
      ABSER=E1+ET
      IPV=IPV_SAV
c      write (*,*) ' vapotail:',RESUL,ICHK
c      if (lwrite) WRITE(*,*) ' vapotail: done'
      RETURN
 98   FORMAT(1X,6(1PE12.4))
 99   FORMAT(1X,I2,2(1PE11.3),I4)
99996 FORMAT (1X,A,I4)
      END
C
       FUNCTION FINT(S)
C      ----------------
       IMPLICIT NONE
       INTEGER  KOUNT
       REAL *8 FINT,S,FACT,S0T,RSt
       COMMON/PAX/S0T,KOUNT
       FINT=RSt(S)*FACT(S)
       KOUNT=KOUNT+1
       RETURN
       END
C
       FUNCTION TINT(T)
C      ----------------
       IMPLICIT NONE
       INTEGER  KOUNT
       REAL *8 TINT,T,TACT,S,S0T,RSt
       COMMON/PAX/S0T,KOUNT
       S=S0T*T/(1D0-T)
       TINT=RSt(S)*TACT(S)/T
       KOUNT=KOUNT+1
       RETURN
       END
C
       FUNCTION XINT(X)
C      ----------------
       IMPLICIT NONE
       INTEGER  KOUNT,IKE,IPV,IREN,IRENO
       REAL *8 X,XINT,S,MP2,M2,S0T,RSt
       EXTERNAL RSt
       COMMON/MFPI/MP2,M2/FFF/IKE,IPV,IREN,IRENO
       COMMON/PAX/S0T,KOUNT
       S=X*X*M2
       IF (IKE.EQ.8) THEN
          XINT=RSt(S)*X*X*EXP(-X)
       ELSE IF (IKE.EQ.9) THEN
          XINT=RSt(S)*X*X*X*EXP(-X)
       ELSE 
          WRITE (*,*) ' Function XINT for Euclidean Correlator:',
     &         ' wrong kernel!' 
       ENDIF
       KOUNT=KOUNT+1
       RETURN
       END
C
       FUNCTION RINT(x)
C      ----------------
       IMPLICIT NONE
       logical lwrite
       INTEGER  KOUNT
       REAL *8 RINT,S,RSt,x,E0,MP2,M2,S0T,LAMBDA
       COMMON/MFPI/MP2,M2
       COMMON/PAX/S0T,KOUNT
       common /pri/lwrite
       E0=SQRT(M2)
       LAMBDA=exp(-sqrt(S0T))
       S=LOG(LAMBDA*x)**2
c       RINT=LAMBDA*RSt(S0T)*2.d0*S*(LAMBDA*x)**(1.d0/E0-1.d0)
       RINT=LAMBDA*11.d0/3.d0*2.d0*S*(LAMBDA*x)**(1.d0/E0-1.d0)
       if (lwrite) write (23,98) x,E0,LAMBDA,RINT 
       KOUNT=KOUNT+1
       RETURN
 98    FORMAT(1X,6(1PE12.4))
       END
C
       FUNCTION TACT(S)
C      ----------------
       IMPLICIT NONE
       INTEGER  IKE,IPV,IREN,IRENO,IGEV,NNLO,IER,NFL
       INTEGER  KOUNT
       REAL *8 TACT,S,S0T,MP2,M2,FK,mm2,me2,k2a,k2aele,k2b,E,E0,ADP,
     &      k3a,k3b,k3bLbL,k3c
       real*8 de,ddk3c,derrdk3c
       real*8 dECgg,derrstaECgg,derrsysECgg,dt,ECLQCDKERN 
       real*8 ml(3)
       common/lema/ml,IGEV
       COMMON/PAX/S0T,KOUNT
       COMMON/MFPI/MP2,M2/FFF/IKE,IPV,IREN,IRENO
       COMMON /NNLO/ADP,NNLO
       COMMON/ERRK3C/IER
       common /flavor/NFL
       EXTERNAL FK,k2a,k2aele,k2b,k3a,k3b,k3bLbL,k3c,ECLQCDKERN
       E =sqrt(S)
       E0=sqrt(M2)
       mm2=ml(2)**2
       me2=ml(1)**2
       if (IGEV.EQ.0) then
          mm2=mm2*1.d6
          me2=me2*1.d6
       endif
       IF(IKE.EQ.0) TACT=FK(S)/S0T
       IF(IKE.EQ.3) TACT=FK(S)/S0T
       IF(IKE.EQ.4) TACT=FK(S)/S0T
       IF(IKE.EQ.1) TACT=M2*S/(S-M2)/S0T
       IF(IKE.EQ.2) TACT=M2*S**2/(S-M2)/(S-M2)/S0T
       IF (NNLO.EQ.1) THEN
          IF(IKE.EQ.5) TACT=k3a(s,mm2)/S0T*S
          IF(IKE.EQ.6) TACT=k3b(s,mm2,me2)/S0T*S
          IF(IKE.EQ.7) TACT=k3bLbL(s,mm2,me2)/S0T*S
       ELSE 
          IF(IKE.EQ.5) TACT=k2a(s,mm2)/S0T*S
          IF(IKE.EQ.6) TACT=k2b(s,mm2,me2)/S0T*S
          IF(IKE.EQ.7) TACT=k2aele(s,me2)/S0T*S
       ENDIF
       IF(IKE.EQ.8) TACT=0.5d0*E*DEXP(-E/E0)/E0**3*S**2/S0T
       IF(IKE.EQ.9) TACT=0.5d0*E**2*DEXP(-E/E0)/E0**4*S**2/S0T
       IF(IKE.EQ.10) TACT=1.d0/S0T
       IF(IKE.EQ.11) TACT=k3c(s,M2,mm2,me2)*S/S0T
       IF(IKE.EQ.12) then
          de=E
          IF (IER.EQ.1) THEN
             call dhadrK3cdist15(de,ddk3c,derrdk3c)
             TACT=S*ddk3c/S0T
          ELSE IF (IER.EQ.3) THEN
             call dhadrK3cdist15(de,ddk3c,derrdk3c)
             TACT=S*derrdk3c/S0T
          ELSE 
             TACT=S/S0T*1d-16
          ENDIF
       ENDIF
       IF(IKE.EQ.13) TACT=k3a(s,me2)*S/S0T
       RETURN               
       END
C
      function RSt(S)
c NF is input (external) takes NF flavors; NFx is output (inetrnal) active number of flavors at given s
      implicit none
      logical lwrite,NFlog
      integer  FTQ,IOR,NF,NFx,ICHK
      real *8 S,R,R3G,R33,RSt,ALINP,EINP,MTOP,pi
      common/var/pi,ALINP,EINP,MTOP,FTQ,IOR,NF,ICHK
      common /pri/lwrite
      if (ICHK.EQ.0) then
         if (ior.gt.3) ior=3
         call rqcd3(S,R,ALINP,EINP,MTOP,FTQ,IOR,NF) 
      else if (ICHK.EQ.1) then
         if (ior.gt.3) ior=3
         call rqcd3m(S,R,ALINP,EINP,MTOP,FTQ,IOR,NF) 
      else if (ICHK.EQ.2) then
c available up to ior=4
         call rqcdHS(S,R,ALINP,EINP,MTOP,IOR,NF)
         if (lwrite) write (103,*) sqrt(s),R,ALINP,EINP,MTOP,IOR,NF
      else 
         call rqcdHS3x(s,R,R3G,R33,ALINP,EINP,MTOP,IOR,NFx)
c         if (ICHK.EQ.3) R=R
c         write (*,*) ' RSt:',ICHK,R,R3G
         if (ICHK.EQ.4) R=R3G
         if (ICHK.EQ.5) R=R33
         if (ICHK.EQ.6) R=R
      endif
c         write (*,*) ' RSt:',ICHK
      if (lwrite) write (102,*) ' RSt:ICHK,E,R',ICHK,sqrt(s),R
      RSt=R
      return
      end
